using System;
using System.Collections;
using OpenGL;
using MT.MathBase;

namespace MT.DataStructures
{
	/// <summary>
	/// Summary description for clsBPDataColor.
	/// </summary>
	public class clsBPDataColor: SortedList
	{
		protected eColorCode	_Color;		//Stores Color of Featurepoint Members
		
		/// <summary>
		/// Gets Color
		/// </summary>
		public eColorCode Color
		{	get { return _Color; }	 }



		public clsBPDataColor(eColorCode Color)
		{
			_Color = Color;

			InitializePaint();

		}

		public virtual void Add(clsBPStream BPStream)
		{
			base.Add(BPStream.Name, BPStream);
		}

		public clsBPStream this[string name]
		{
			get
			{
				return (clsBPStream)base[name];
			}
			set
			{
				base[name] = value;
			}
		}

		vector3f _paintColor;

		private void InitializePaint()
		{
			switch (_Color)
			{
				case eColorCode.R:
					_paintColor = new vector3f(1,0,0);
					break;
				case eColorCode.G:
					_paintColor = new vector3f(0,1,0);
					break;
				case eColorCode.B:
					_paintColor = new vector3f(0,0,1);
					break;
				default:
					_paintColor = new vector3f(0,0,0);
					break;
			}
		}

		public clsBPFrame getFrame(int frameID)
		{
			clsBPFrame BPFrame = new clsBPFrame(frameID);

			foreach (clsBPStream BPStream in base.Values)
			{
				BPFrame.Add(BPStream.Name,BPStream[frameID]);
			}

			return BPFrame;
		}

		public virtual void Paint(int frameID)
		{
			//Set Color
			GL.glColor3f(_paintColor.X, _paintColor.Y ,_paintColor.Z);

			foreach(clsBPStream BPStream in base.Values)
			{
				BPStream.Paint(frameID);
			}
		}

	}
}
