using System;
using System.Collections;

namespace MT.DataStructures
{
	/// <summary>
	/// Zusammenfassung fr clsFPFrameArrayColor.
	/// </summary>
	public class clsFPFrameArrayColor: SortedList
	{

		protected eColorCode	_Color;		//Stores Color of Featurepoint Members
		protected int			_fid;		//Stores FrameID

		/// <summary>
		/// Gets FrameColor
		/// </summary>
		public eColorCode Color
		{	get { return _Color; }	 }

		/// <summary>
		/// Gets the Framenumber
		/// </summary>
		public int fid
		{	get { return _fid; }	 }

		public clsFPFrameArrayColor(eColorCode Color, int fid)
		{
			_Color = Color;
			_fid = fid;
		}
		//Dummy Constructor required for StringDeserialization
		protected clsFPFrameArrayColor()
		{
		}

		/// <summary>
		/// Add a frame from a Camera to the Array
		/// </summary>
		/// <param name="frame">Frame</param>
		/// <param name="cid">Camera ID (CameraName)</param>
		public virtual void Add(string cid, FeaturePointFrame frame)
		{
			base.Add(cid, frame);
		}

		public	FeaturePointFrame Frame			(string cid)
		{	
			return (FeaturePointFrame)base[cid];
		}

		public virtual FeaturePointFrameColor this[string cid]
		{
			get
			{
				return (FeaturePointFrameColor)base[cid];
			}
			set
			{
				base[cid] = value;
			}
		}


	}
}
