using System;
using System.Collections;
using System.IO;

namespace MT.DataStructures
{
	/// <summary>
	/// clsFPFrameArrayContainer contains all Timesynchron FP Data from all cameras. It is mainly a sorted
	/// List, but with a save and load extension that allows us to save all contained data to a file.
	/// </summary>
	public class clsFPFrameArrayContainer : SortedList
	{
		public clsFPFrameArrayContainer()
		{
			
		}

		public void Save(string filename)
		{
			// ToDo: Save Function is not implemented in the GUI yet.
			StreamWriter Saver = new StreamWriter("test.txt");

			//Each Line stores one FeaturePoint Frame Array
			foreach (clsFPFrameArray FPFrameArray in base.Values)
			{
				Saver.WriteLine(FPFrameArray.ToString());
			}
		}
	

		public void Load(string filename)
		{
			StreamReader Loader = new StreamReader(filename);

			string strFPFrameArray = "";
			clsFPFrameArray Array;


			while ((strFPFrameArray = Loader.ReadLine())!=null)
			{
				Array = new clsFPFrameArray(strFPFrameArray);
				base.Add(Array.fid, Array);
			}
		}

	}
}
