using System;
using System.Runtime.InteropServices;
using System.Data;
using DShowNET;
using System.Drawing.Imaging;
using System.Drawing;
using MT.DataStructures;
using GraphController;

namespace MT.FPSource
{
	/// <summary>
	/// Zusammenfassung fr Class1.
	/// </summary>
	public class FPDetector: VideoGrabber, IFPsource
	{

//		//declare Event Delegates
//		public delegate void NewFrameDelegate(FeaturePointFrame FPframe);

		//declare Events
		public event NewFrameDelegate NewFrame ;

		private int					_frameNr;							// Frame Nr.
		private int					_blackpixel;
		private int					_rotanteil;
		private int					_gruenanteil;
		private int					_blauanteil;
		private bool				_Synchro = false;
		private bool				_firstframe;
		private int					_firstframehelligkeit;
		private int					_param2 = 20;
		private int					_param3 = 5;
		private int					_Sync;
		//Bitmap	_bitmapIn;							// Originalbild
		Bitmap	_bitmapOut;							// Bearbeitetes Bild


		public int Sync
		{
			set { _Sync = value; }
		}


		public FPDetector(ISampleGrabber sampGrabber ): base(sampGrabber)
		{
			base.NewPicture += new NewPictureDelegate(this.Detection);
		}

		public struct Zonen
		{
			public int  Nr;							// Zonennummer
			public float X;							// X-Koordinate (Schwerpunkt einer Zone)
			public float Y;							// Y-Koordinate (Schwerpunkt einer Zone)
			public float R;							// Rot-Anteil
			public float G;							// Grn-Anteil
			public float B;							// Blau-Anteil
			public char  F;							// Maximale Farbe
			public int  Gw;							// Gewichtung (Anzahl beteiligter Pixel an einer Zone)
		};

		public struct PixelRGB
		{
			public int[] RGB;
		}

		public void Detection(Bitmap bitmapIn)
		{
			//CAutoLock cAutolock(&m_SWFilterLock);

//			AMMediaType pmt = new AMMediaType(); //= &(m_pInput->CurrentMediaType()); 
//			streamConfig.GetFormat(out pmt);
//			VideoInfoHeader pvi = (VideoInfoHeader) Marshal.PtrToStructure( pmt.formatPtr, typeof(VideoInfoHeader) );
//			DsUtils.FreeAMMediaType(pmt);
    
			_bitmapOut		    = (Bitmap)bitmapIn.Clone();
			BitmapData bmData   = _bitmapOut.LockBits(new Rectangle(0, 0, _bitmapOut.Width, _bitmapOut.Height), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb); 
			int stride		    = bmData.Stride;		// bytes in a row 3*b.Width
			System.IntPtr Scan0 = bmData.Scan0;
			int iImgWidth		= _bitmapOut.Width;		// Bildbreite

//			IntPtr pData;                // Pointer to the actual image buffer
//			long lDataLen;              // Holds length of any given sample
			int iPixel;                 // Used to loop through the image pixels

//			pMediaSample.GetPointer(out pData);
//			lDataLen = pMediaSample.GetSize();

			// Get the image properties from the BITMAPINFOHEADER
			int iPixelSize    = 3;
			//int iPixelSize    = pvi.BmiHeader.BitCount / 8;
			int cxImage       = _bitmapOut.Width;
			int cyImage       = _bitmapOut.Height;
			int cbImage       = cyImage * cxImage * iPixelSize;
			int numPixels     = cxImage * cyImage;

			
			Zonen[]  Liste = new Zonen[50];
			int  aktZoneNr    = 0;
			int  i, j         = 0;
			int  AnzahlZonen  = 0;

			int	 Helligkeit	  = 0;
			int	 Sync = _Sync;
			bool firstdarkframe = false;


			for (i=0; i<50; i++) 
			{
				
				Liste[i].Nr = 0; Liste[i].X = 0; Liste[i].Y = 0; Liste[i].R  = 0;
				Liste[i].G  = 0; Liste[i].B = 0; Liste[i].F = '0'; Liste[i].Gw = 0;
			}
			
			// Transform

			// Synchronisation
			// ***************
			// Solange die Helligkeit einen gewissen Wert (param5) bersteigt, wird das Frame nicht bearbeitet.
			// Erst wenn dieser Wert nicht erreicht wird beginnt der Algorithmus zu wirken.

			unsafe
			{
				byte * prgb			= (byte *)(void *)Scan0;
				byte * prgbsave		= (byte *)(void *)Scan0;
			
			
				if (_Synchro)
				{
					for (iPixel=0; iPixel < numPixels; iPixel++ ) 
					{
						Helligkeit   += prgb[iPixelSize * iPixel    ] +
							prgb[iPixelSize * iPixel + 1] +
							prgb[iPixelSize * iPixel + 2];
					}

					if (_firstframe == true) 
					{
						_firstframehelligkeit = Helligkeit;
					}

					if ( Helligkeit < 0.9 * _firstframehelligkeit && _firstframe == false)
					{
						_Synchro        = false;
						firstdarkframe = true;
					}

					_firstframe = false;
			
				}

				if (!_Synchro)
				{
		
					// erstes Frame berprfen
					// ***********************
					// Dies ist das erste Frame im Dunkeln. Es wird jeweils der Mittelwert der drei Farbkanle gebildet,
					// und anschliessend im Algorithmus bercksichtigt resp. abgezogen. Dies war ntig, da der Blaukanal
					// bei einem dunklen Bild bereits einen Wert von etwa 40 hatte, whrend Rot und Grn zwischen 0 und 5
					// schwankten. 
					if (firstdarkframe)
					{
						_blackpixel   = 0;
						_rotanteil    = 0;
						_gruenanteil  = 0;
						_blauanteil   = 0; 

						for (iPixel=0; iPixel < numPixels; iPixel++ ) 
						{
							if((0.11 * prgb[iPixelSize * iPixel    ] + 
								0.69 * prgb[iPixelSize * iPixel + 1] + 
								0.4  * prgb[iPixelSize * iPixel + 2] ) < _param2)
							{
								_blackpixel ++;
								_rotanteil   += prgb[iPixelSize * iPixel + 2];
								_gruenanteil += prgb[iPixelSize * iPixel + 1];
								_blauanteil  += prgb[iPixelSize * iPixel    ];
							}
						}
						_rotanteil   /= _blackpixel;
						_gruenanteil /= _blackpixel;
						_blauanteil  /= _blackpixel;

						//_rotanteil   =0;
						//_gruenanteil =0;
						//_blauanteil  =0;

					}




					// 1. Zonensuche
					// ****************

					// erste Zeile schwarz frben
					for (iPixel=0; iPixel<cxImage+1; iPixel ++)
					{
						prgb[iPixelSize * iPixel    ] = 0;
						prgb[iPixelSize * iPixel + 1] = 0;
						prgb[iPixelSize * iPixel + 2] = 0;
					}
					// letzte Zeile schwarz frben
					for (iPixel=numPixels-cxImage-1; iPixel<numPixels; iPixel ++)
					{
						prgb[iPixelSize * iPixel    ] = 0;
						prgb[iPixelSize * iPixel + 1] = 0;
						prgb[iPixelSize * iPixel + 2] = 0;
					}

					prgb+=(cxImage+1)*iPixelSize;
					for (iPixel=cxImage+1; iPixel < numPixels-cxImage-1; iPixel++, prgb+=iPixelSize) 
					{
						if((0.11 * *(prgb    ) +
							0.69 * *(prgb + 1) +
							0.4  * *(prgb + 2)   ) > _param2)	
						{
							if (aktZoneNr < 49)
							{
								aktZoneNr++;
								suche( cxImage, cyImage, aktZoneNr, prgb, iPixelSize, ref Liste, prgbsave, 0);
								
								//Falls weniger als "Parameter 3" Pixel an einer Zone beteiligt sind, wird die Zone gelscht
								if ( Liste[aktZoneNr].Gw < _param3)
								{
									Liste[aktZoneNr].Nr = 0;
									Liste[aktZoneNr].X  = 0;
									Liste[aktZoneNr].Y  = 0;
									Liste[aktZoneNr].R  = 0;
									Liste[aktZoneNr].G  = 0;
									Liste[aktZoneNr].B  = 0;
									Liste[aktZoneNr].F  = '0';
									Liste[aktZoneNr].Gw = 0;
									aktZoneNr--;
								}
						
								else
								{
									Liste[aktZoneNr].X = Liste[aktZoneNr].X / Liste[aktZoneNr].Gw;	// Durchschnitt bilden
									Liste[aktZoneNr].Y = Liste[aktZoneNr].Y / Liste[aktZoneNr].Gw;
									Liste[aktZoneNr].R = Liste[aktZoneNr].R / Liste[aktZoneNr].Gw;
									Liste[aktZoneNr].G = Liste[aktZoneNr].G / Liste[aktZoneNr].Gw;
									Liste[aktZoneNr].B = Liste[aktZoneNr].B / Liste[aktZoneNr].Gw;
									Liste[aktZoneNr].F = maxFarbe(Liste[aktZoneNr].R, Liste[aktZoneNr].G, Liste[aktZoneNr].B);
								}
							}
						}
						*(prgb    ) = 0;
						*(prgb + 1) = 0;
						*(prgb + 2) = 0;
					}


					// 2. Benachbarte Zonen innerhalb 10 Pixel und gleicher Farbe zusammenfassen
					// *************************************************************************

					AnzahlZonen = aktZoneNr;
					for (i=1; i<=aktZoneNr; i++)
					{
						for (j=i+1; j<=aktZoneNr; j++)
						{
							if ( (Math.Abs(Liste[i].X - Liste[j].X)) < 10 &&
								(Math.Abs(Liste[i].Y - Liste[j].Y)) < 10 &&
								Liste[i].F == Liste[j].F            &&
								i != j)
							{
								Liste[i].X  = (Liste[i].X*Liste[i].Gw + Liste[j].X*Liste[j].Gw) / (Liste[i].Gw+Liste[j].Gw);
								Liste[i].Y  = (Liste[i].Y*Liste[i].Gw + Liste[j].Y*Liste[j].Gw) / (Liste[i].Gw+Liste[j].Gw);
								Liste[i].R  = (Liste[i].R + Liste[j].R) / 2;
								Liste[i].G  = (Liste[i].G + Liste[j].G) / 2;
								Liste[i].B  = (Liste[i].B + Liste[j].B) / 2;
								Liste[i].Gw = Liste[i].Gw + Liste[j].Gw;

								Liste[j].Nr = 0;
								Liste[j].X  = 0;
								Liste[j].Y  = 0;
								Liste[j].R  = 0;
								Liste[j].G  = 0;
								Liste[j].B  = 0;
								Liste[j].F  = '0';
								Liste[j].Gw = 0;
								AnzahlZonen--;
							}
						}
					}


					// Kreuze zeichnen
					// ***************

					if(aktZoneNr<50) // Verhindert, dass am Ende des Videos zu viele Kreuze gezeichnet werden
					{
						for (i=0; i<=aktZoneNr; i++)
						{
							if (Liste[i].Nr != 0)
							{
								prgb = prgbsave;
								drawCross( prgb, cxImage, cyImage, iPixelSize, (int)Liste[i].X, (int)Liste[i].Y, Liste[i].Gw, Liste[i].F);
							}
						}
					}


					

					//if(firstdarkframe == true) {m_SWFilterParams.param5=1; SetParams(&m_SWFilterParams);}
			
				}
			}

			//m_SWFilterParams.param7++;
			_bitmapOut.UnlockBits(bmData);


			//Create new FP Frame Class
			FeaturePointFrame	newFrame = new FeaturePointFrame(_frameNr,"");
			newFrame.Sync = Sync;

			FeaturePoint P;

			foreach (Zonen Zone in Liste)
			{
				if (Zone.Gw > 0)
				{
					//Create a new Feature Point with Coords out of the parsed Values of myarray
					// ToDo: May cause Problems that we hardcoded Picturesize (480)
					P = new FeaturePoint(Zone.X, Zone.Y,(eColorCode)(int)Zone.F,Zone.Nr);

					//Store new Point into all List
					newFrame.Add(P);
				}

			}

			//Raise Event to announce new parsed Frame
			if(NewFrame!=null)
				NewFrame(newFrame);

			_frameNr++;

//			return _bitmapOut;
		}

		
		public char maxFarbe( float rot, float gruen, float blau)
		{
			// rot = 0, gruen = 1, blau = 2, weiss = 3
			if (rot>gruen && rot>blau)   {return 'R';}
			if (gruen>rot && gruen>blau) {return 'G';}
			else                         
			{ 
				if (blau-gruen > 60) 
					{return 'B';}
				else					
					{return 'B';}
			}	// weiss
		}
	
		unsafe public void suche( int cxImage, int cyImage,	int aktZoneNr, byte * prgb, int iPixelSize, ref Zonen[] Liste,	byte * prgbsave,int tiefe)		
		{
				if (tiefe < 50)
				{
					tiefe++;
					int Pixel  = (int)(prgb-prgbsave)/iPixelSize;						// Aktuelle Position im Frame berechnen

					if( Pixel > (cxImage + 1) && Pixel < ((cxImage * cyImage) - cxImage - 1) ) // Ist der Pixel innerhalb des Bildes?
					{
						char color = maxFarbe( *(prgb + 2), *(prgb + 1), *prgb);	// Farbe des Pixels bestimmen
						Liste[aktZoneNr].Nr  = aktZoneNr;
						Liste[aktZoneNr].X  += (int)Pixel%cxImage;
						Liste[aktZoneNr].Y  += (int)Pixel/cxImage;
						Liste[aktZoneNr].R  += *(prgb + 2) - _rotanteil;			// Durchschnittlicher Rotanteil des ersten Frame.
						Liste[aktZoneNr].G  += *(prgb + 1) - _gruenanteil;
						Liste[aktZoneNr].B  += *(prgb    ) - _blauanteil; 
						Liste[aktZoneNr].Gw++;										//   Anzahl Pixel, die an einer Zone beteiligt sind
						*(prgb    ) = 0;											//  |
						*(prgb + 1) = 0;											//   >Pixel schwarz frben
						*(prgb + 2) = 0;							//  |


						//unten links
						if ( (0.11 * *(prgb-((cxImage+1)*iPixelSize)     ) + 
							0.69 * *(prgb-((cxImage+1)*iPixelSize)  + 1) +
							0.4  * *(prgb-((cxImage+1)*iPixelSize)  + 2))  > _param2 &&
							(Pixel-cxImage+1) / cxImage  == (Pixel / cxImage) + 1 &&
							color == maxFarbe(*(prgb-((cxImage+1)*iPixelSize) + 2 ),
							*(prgb-((cxImage+1)*iPixelSize) + 1 ),
							*(prgb-((cxImage+1)*iPixelSize)     ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb-((cxImage+1)*iPixelSize), iPixelSize, ref Liste, prgbsave, tiefe);} 


						//links
						if ( (0.11 * *(prgb-iPixelSize    ) +
							0.69 * *(prgb-iPixelSize + 1) +
							0.4  * *(prgb-iPixelSize + 2))  > _param2 &&
							(Pixel-iPixelSize)/ cxImage == ( Pixel / cxImage) &&
							color == maxFarbe(*(prgb-iPixelSize + 2),
							*(prgb-iPixelSize + 1),
							*(prgb-iPixelSize    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb-(1*iPixelSize) , iPixelSize,ref Liste, prgbsave, tiefe);} 


						//oben links
						if ( (0.11 * *(prgb+((cxImage-1)*iPixelSize)    ) + 
							0.69 * *(prgb+((cxImage-1)*iPixelSize) + 1) + 
							0.4  * *(prgb+((cxImage-1)*iPixelSize) + 2))  > _param2 &&
							(Pixel+cxImage-1) / cxImage == (Pixel / cxImage) - 1 &&
							color == maxFarbe(*(prgb+((cxImage-1)*iPixelSize) + 2),
							*(prgb+((cxImage-1)*iPixelSize) + 1),
							*(prgb+((cxImage-1)*iPixelSize)    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb+((cxImage-1)*iPixelSize), iPixelSize,ref Liste, prgbsave, tiefe);} 


						//oben
						if ( (0.11 * *(prgb+(cxImage*iPixelSize)    ) + 
							0.69 * *(prgb+(cxImage*iPixelSize) + 1) + 
							0.4  * *(prgb+(cxImage*iPixelSize) + 2))  > _param2 &&
							color == maxFarbe(*(prgb+(cxImage*iPixelSize) + 2),
							*(prgb+(cxImage*iPixelSize) + 1),
							*(prgb+(cxImage*iPixelSize)    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb+((cxImage)*iPixelSize),   iPixelSize,ref Liste, prgbsave, tiefe);} 


						//oben rechts
						if ( (0.11 * *(prgb+((cxImage+1)*iPixelSize)    ) + 
							0.69 * *(prgb+((cxImage+1)*iPixelSize) + 1) + 
							0.4  * *(prgb+((cxImage+1)*iPixelSize) + 2))  > _param2 &&
							(Pixel+cxImage+1) / cxImage == (Pixel / cxImage) +1 &&
							color == maxFarbe(*(prgb+((cxImage+1)*iPixelSize) + 2),
							*(prgb+((cxImage+1)*iPixelSize) + 1),
							*(prgb+((cxImage+1)*iPixelSize)    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb+((cxImage+1)*iPixelSize), iPixelSize,ref Liste, prgbsave, tiefe);} 


						//rechts
						if ( (0.11 * *(prgb+iPixelSize    ) + 
							0.69 * *(prgb+iPixelSize + 1) + 
							0.4  * *(prgb+iPixelSize + 2))  > _param2 &&
							(Pixel+iPixelSize)/ cxImage == ( Pixel / cxImage) &&
							color == maxFarbe(*(prgb+iPixelSize + 2),
							*(prgb+iPixelSize + 1),
							*(prgb+iPixelSize    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb+(1*iPixelSize) , iPixelSize,ref Liste, prgbsave, tiefe);} 


						//unten rechts
						if ( (0.11 * *(prgb-((cxImage-1)*iPixelSize)    ) + 
							0.69 * *(prgb-((cxImage-1)*iPixelSize) + 1) + 
							0.4  * *(prgb-((cxImage-1)*iPixelSize) + 2))  > _param2 &&
							(Pixel-cxImage-1) / cxImage  == (Pixel / cxImage) +1 &&
							color == maxFarbe(*(prgb-((cxImage-1)*iPixelSize) + 2),
							*(prgb-((cxImage-1)*iPixelSize) + 1),
							*(prgb-((cxImage-1)*iPixelSize)    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb-((cxImage-1)*iPixelSize), iPixelSize,ref  Liste, prgbsave, tiefe);} 


						//unten
						if ( (0.11 * *(prgb-(cxImage*iPixelSize)    ) + 
							0.69 * *(prgb-(cxImage*iPixelSize) + 1) +
							0.4  * *(prgb-(cxImage*iPixelSize) + 2))  > _param2 &&
							color == maxFarbe(*(prgb-(cxImage*iPixelSize) + 2),
							*(prgb-(cxImage*iPixelSize) + 1),
							*(prgb-(cxImage*iPixelSize)    ) ) )

						{ suche( cxImage, cyImage, aktZoneNr, prgb-((cxImage)*iPixelSize),   iPixelSize,ref Liste, prgbsave, tiefe);} 
					}
				} 
//			} // end unsafe
		}	// end suche	

	

		unsafe public void drawCross(byte* prgb, int cxImage, int cyImage, int iPixelSize, int xCoord, int yCoord, int Gewicht, char Farbe)
		{
//			unsafe
//			{
				int rot = 0; 
				int gruen = 0;
				int blau = 0;
				if (Farbe == 'R') {rot = 255; gruen =   0; blau =   0;}
				if (Farbe == 'G') {rot =   0; gruen = 255; blau =   0;}
				if (Farbe == 'B') {rot =   0; gruen =   0; blau = 255;}
				if (Farbe == 'W') {rot = 255; gruen = 255; blau = 255;}


				for (int x=-Gewicht/20; x<=Gewicht/20; x ++)
				{
					// Horizontale Linie
					if ( (prgb + iPixelSize*((yCoord*cxImage) + xCoord + x)) > prgb &&
						(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x)) < prgb + iPixelSize*cxImage*cyImage &&
						yCoord == yCoord + ((xCoord + x) / cxImage)  &&
						(xCoord + x) >= 0 )
					{
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x)    ) = (byte)blau;
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x) + 1) = (byte)gruen;
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x) + 2) = (byte)rot;

					}

					// Vertikale Linie
					if ( (prgb + iPixelSize*((yCoord*cxImage) + xCoord + x*cxImage)) > prgb &&
						(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x*cxImage)) < prgb + iPixelSize*cxImage*cyImage)
					{
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x*cxImage)    ) = (byte)blau;
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x*cxImage) + 1) = (byte)gruen;
						*(prgb + iPixelSize*((yCoord*cxImage) + xCoord + x*cxImage) + 2) = (byte)rot;
						}     
				}
//			}//end unsafe
		} //end drawCross
		#region IFPsource Member

		public void Activate()
		{
			this.Enable();
		}

		public void Deactivate()
		{
			this.Disable();
		}

		#endregion
	} // end class FPDetector
} // end Namespace
