using System;
using System.Drawing;
using tsai;
using MT.DataStructures;

namespace GraphController
{
	//declare Event Delegates
	public delegate void NewFrameDelegate(FeaturePointFrame FPframe);

	/// <summary>
	/// Zusammenfassung fr IFPsource.
	/// </summary>
	public interface IFPsource
	{

		//declare Events
		event NewFrameDelegate NewFrame ;

		void Activate();
		void Deactivate();
	}

	public interface IFPsink
	{
		void Send(FeaturePointFrame FPframe);
	}

	public delegate void NewPictureDelegate(Bitmap b);

	public interface IPictureGrabber
	{
		event NewPictureDelegate NewPicture;

		Bitmap GrabPicture();
	}

	public interface ICalibSink
	{
		void Send(tsai_converter tc);
	}
}
