using System;
using System.IO;
using MT.DataStructures;

namespace MT.Tracker
{
	/// <summary>
	/// Summary description for FrameSaver.
	/// </summary>
	public class FrameSaver
	{
		private string	mstrPath;
		private string	mstrName;
		private int		mintDigits;
		private string	mstrEnding;

		public FrameSaver(string Path, string Name, string Ending, int Digits)
		{
			mstrPath = Path;
			mstrName = Name;
			mintDigits = Digits;
			mstrEnding = Ending;
		}

		public void SaveFrame(int fnr, FeaturePoint[] myPoints)
		{
			string strMaxDigits = "";
			int i = 0;			//for..next

			//Create Digits Conversion String
			for (i=0;i<mintDigits;i++)
			{
					strMaxDigits +="0";
			}

			StreamWriter mywriter = null;
			
			//Try to open File
			try { mywriter = new StreamWriter(mstrPath + mstrName + fnr.ToString(strMaxDigits) + "." + mstrEnding); }
			catch { Console.WriteLine("ERROR: Could not open File \"" + mstrPath + mstrName + fnr.ToString(strMaxDigits) + "." + mstrEnding + "\""); }		
	
			//Try to write date into file
			try 
			{	
				mywriter.WriteLine("Frame        :{0}",fnr);
				mywriter.WriteLine("Anzahl Zonen :{0}",myPoints.Length);
				mywriter.WriteLine("");
				mywriter.WriteLine("Zone	X	Y	R	G	B	F	Gw	V	T");
				mywriter.WriteLine("-----------------------------------------------------------------------------------");
				for (i=0; i<myPoints.Length;i++)
				{	mywriter.WriteLine("{0}	{1}	{2}	{3}	{4}	{5}	{6}	{7}	{8}	{9}",
						i,
						myPoints[i].X,
						myPoints[i].Y,
						" ",
						" ",
						" ",
						myPoints[i].Color,
						" ",
						0,
						myPoints[i].tid);
				}
				mywriter.Close();
			}
			catch { Console.WriteLine("ERROR: Could not write data to File!"); }

		}


	}
}
