using System;
using System.Collections;

namespace MT.Tracker
{		
	/// <summary>
	/// This is a Sorted Collection of all Hypothesises that have been added.
	/// </summary>
	public class HypothesisSet: SortedList
	{	

		private int _index = 0;		//h_index gives each Hypothesis a Rank that prevents collisions in the
									//Sortedlist by Costequivalencies -> Key=String.Concat(H.Index,"_",H.Cost)
	
		private float _cost = 0;	//Stores Total Cost of all Hypotheses in the set

		public HypothesisSet()
		{
			//
			// TODO: Fgen Sie hier die Konstruktorlogik hinzu
			//
		}


		public void Add(Hypothesis H) 
		{	//Increase Index and store it in the Hypothesis if it has not been set yet.
			//This demands that we do not exchange Hypothesises which have been 
			//stored in different Sets when they were created, since this could provoke
			//collisions. Since the tracker does not do this it should not lead
			//to any problems.
			if(H.Index==0) H.Index = ++_index;
			base.Add(String.Concat(H.Cost, "_", H.Index),H);

			_cost += H.Cost;
		}

		new public Hypothesis GetByIndex(int index)
		{
			return (Hypothesis)base.GetByIndex(index);
		}


		public float Cost
		{
			get { return _cost; }
		}
		

//		new private void Add(object key, object value) 
//		{ base.Add(key,value);
//		}

	}



//	public class HypothesisSet_DictionaryEntry: DictionaryEntry
//	{
//		HypothesisSet_DictionaryEntry(string key, Hypothesis H): base(key,H)
//		{	
//		}
//
//		public string Key
//		{
//			get { return (string)base.Key; }
//		}
//
//		public Hypothesis Value
//		{
//			get {return (Hypothesis)base.Value; } 
//		}
//	}

//	public class Hypothesis_Enumerator: IDictionaryEnumerator
//	{
//		HypothesisSet _HS;
//		int _index = -1;
//
//
//		Hypothesis_Enumerator(HypothesisSet HS)
//		{
//			_HS = HS;
//		}
//
//		public Hypothesis Current
//		{
//			get { return _HS.GetByIndex(_index); }
//		}
//
//		public bool MoveNext()
//		{	bool r;
//			if (_index < _HS.Count-1)
//			{
//				_index++;
//				return true;
//			}
//			else
//			{
//				return false;
//			}
//		}
//
//		public void Reset()
//		{
//			_index = -1;
//		}
//
//		public DictionaryEntry Entry 
//		{
//			get{ return new DictionaryEntry(_HS.GetKey(_index),_HS.GetByIndex(_index)); }
//		}
//
//		public object Key
//		{
//			get { return (string)_HS.GetKey((_index)); }
//		}
//
//		public object Value
//		{
//			get { return _HS.GetByIndex(_index); }
//		}
//
//
//
//	}
}
