using System;
using MT.Filter.Server;
using DShowNET;
using GraphController;

namespace MTClient
{
	public delegate void NewConnectionStateDelegate(string message);

	/// <summary>
	/// Zusammenfassung fr clsClient.
	/// </summary>
	public class clsFilterServer
	{
		ISWFilter _SWFilter;
		public event NewConnectionStateDelegate NewConnectionState;


		private clsFPnetReceiver _Server;

		public clsFPnetReceiver Server
		{ get { return _Server; }
		}


		public clsFilterServer(ISWFilter SWFilter)
		{
			_SWFilter = SWFilter;
		}

		/// <summary>
		/// Starts a Server and returns true when initalization was successful.
		/// </summary>
		/// <returns></returns>
		public bool Start()
		{
			try
			{
				_Server = new clsFPnetReceiver(2345, _SWFilter);

				//Connect Eventdelegates
				this._Server.NewConnection += new Server.NewConnectionDelegate(_Server_NewConnection);
				//this._Server.NewMessage += new Server.NewMessageDelegate(_Server_NewMessage);
				this._Server.ClosedConnection += new Server.ClosedConnectionDelegate(_Server_ClosedConnection);
				
				if (NewConnectionState !=null)
					NewConnectionState("Filter: Nicht verbunden");

				return true;
			}
			catch (System.Net.Sockets.SocketException ex)
			{			
				Stop();
				Console.WriteLine("An exception occured while trying to start the FilterServer! {0}",ex);
				return false;
			}
		}

		public void Stop()
		{
			if (_Server!=null) 
			{
				_Server.Dispose();
				_Server=null;
			}
		}

		private void _Server_NewConnection(string ConID)
		{
			if (NewConnectionState !=null)
				NewConnectionState("Filter: Verbunden");
		}

		private void _Server_ClosedConnection(string ConID)
		{
			//ClosedConnection(ConID);
			if (NewConnectionState !=null)
				NewConnectionState("Filter: Nicht verbunden");
		}

	}
}
