using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MT.Filter.Server;
using MT.DataStructures;
using MT.Tracker;
namespace MTClient
{
	/// <summary>
	/// Summary description for uscTracker.
	/// </summary>
	public class uscTracker : System.Windows.Forms.UserControl
	{
		private bool _updatingParameters = false;

		private enum enuTrackerState
		{
			inactive,
			XY,
			XT,
			TY,
			Hypothesises
		}

//		//declare Event Delegates
//		public delegate void NewConnectionStateDelegate();
//		public delegate void FrameCountDelegate(int fps);
//
//		//declare Events
//		public event NewConnectionStateDelegate NewConnectionState;
//		public event FrameCountDelegate FrameCount;

		// Contains the state of the viewer
		private enuTrackerState eState = enuTrackerState.XY;

		private FeaturePointData _data;	//Stores all Featurepoint Data
		//private int currentFrame=1;
		//private int nrOfFrames=5;
		private int _intFPSize = 3;
		private bool _blnShowFP = true;
		private bool _blnMarkCurrentFrame = true;
		private bool _blnShowTrajectories = true;
		private bool _blnShowRed = true;
		private bool _blnShowGreen = true;
		private bool _blnShowBlue = true;
		private bool _blnShowCalculated = true;
		private bool _blnShowMeasured = true;
		private bool _blnShowTrajectoryID = true;
		
		private bool _blnUpdating = false;

//		private System.Windows.Forms.Timer _FrameCounter;
		private clsTracker _Tracker;

		private System.Windows.Forms.PictureBox pcbTracker;
		private System.Windows.Forms.Label lblSizeOfFP;
		private System.Windows.Forms.NumericUpDown nudFPSize;
		private System.Windows.Forms.Label lblNrOfFrames;
		private System.Windows.Forms.Label lblCurrentFrame;
		private System.Windows.Forms.Label lblNrOfFrameslbl;
		private System.Windows.Forms.Label lblCurrentFramelbl;
		private System.Windows.Forms.RadioButton rdbViewXY;
		private System.Windows.Forms.RadioButton rdbViewXT;
		private System.Windows.Forms.RadioButton rdbViewTY;
		private System.Windows.Forms.Button btnPauseView;
		private System.Windows.Forms.Button btnContinueView;
		private System.Windows.Forms.Button btnStopSource;
		private System.Windows.Forms.Button btnStartSource;
		private System.Windows.Forms.RadioButton rdbViewHypothesises;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.TabControl tbcSettings;
		private System.Windows.Forms.TabPage tbpView;
		private System.Windows.Forms.TabPage tbpConfig;
		private System.Windows.Forms.CheckBox ckbShowBlue;
		private System.Windows.Forms.CheckBox ckbShowGreen;
		private System.Windows.Forms.CheckBox ckbShowRed;
		private System.Windows.Forms.CheckBox chkShowMeasured;
		private System.Windows.Forms.CheckBox chkShowCalculated;
		private System.Windows.Forms.CheckBox ckbShowTrajectories;
		private System.Windows.Forms.CheckBox ckbShowFP;
		private System.Windows.Forms.CheckBox ckbMarkCurrentFrame;
		private System.Windows.Forms.CheckBox chkShowTrajectoryID;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ListBox lsbHypothesises;
		private System.Windows.Forms.TabPage tbpParameters;
		private System.Windows.Forms.Label lblVmin;
		private System.Windows.Forms.Label lblVnrm;
		private System.Windows.Forms.Label lblVmax;
		private System.Windows.Forms.Label lblGmax;
		private System.Windows.Forms.TextBox txtVnrm;
		private System.Windows.Forms.TextBox txtVmax;
		private System.Windows.Forms.TextBox txtDmax;
		private System.Windows.Forms.TextBox txtVmin;
		private MTClient.uscTrackerTrackbar uOmega;
		private System.ComponentModel.IContainer components;

		public uscTracker()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			SeedData();
			
			//			_FrameCounter = new System.Windows.Forms.Timer();
			//			_FrameCounter.Interval = 1000;
			//
			//			_FrameCounter.Tick +=new EventHandler(TimerEventProcessor);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pcbTracker = new System.Windows.Forms.PictureBox();
			this.rdbViewXY = new System.Windows.Forms.RadioButton();
			this.rdbViewXT = new System.Windows.Forms.RadioButton();
			this.rdbViewTY = new System.Windows.Forms.RadioButton();
			this.lblSizeOfFP = new System.Windows.Forms.Label();
			this.nudFPSize = new System.Windows.Forms.NumericUpDown();
			this.lblNrOfFrames = new System.Windows.Forms.Label();
			this.lblCurrentFrame = new System.Windows.Forms.Label();
			this.lblNrOfFrameslbl = new System.Windows.Forms.Label();
			this.lblCurrentFramelbl = new System.Windows.Forms.Label();
			this.btnPauseView = new System.Windows.Forms.Button();
			this.btnContinueView = new System.Windows.Forms.Button();
			this.btnStopSource = new System.Windows.Forms.Button();
			this.btnStartSource = new System.Windows.Forms.Button();
			this.rdbViewHypothesises = new System.Windows.Forms.RadioButton();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.tbcSettings = new System.Windows.Forms.TabControl();
			this.tbpView = new System.Windows.Forms.TabPage();
			this.chkShowTrajectoryID = new System.Windows.Forms.CheckBox();
			this.ckbMarkCurrentFrame = new System.Windows.Forms.CheckBox();
			this.ckbShowFP = new System.Windows.Forms.CheckBox();
			this.ckbShowTrajectories = new System.Windows.Forms.CheckBox();
			this.chkShowCalculated = new System.Windows.Forms.CheckBox();
			this.chkShowMeasured = new System.Windows.Forms.CheckBox();
			this.ckbShowBlue = new System.Windows.Forms.CheckBox();
			this.ckbShowGreen = new System.Windows.Forms.CheckBox();
			this.ckbShowRed = new System.Windows.Forms.CheckBox();
			this.tbpConfig = new System.Windows.Forms.TabPage();
			this.label1 = new System.Windows.Forms.Label();
			this.lsbHypothesises = new System.Windows.Forms.ListBox();
			this.tbpParameters = new System.Windows.Forms.TabPage();
			this.uOmega = new MTClient.uscTrackerTrackbar();
			this.lblVmin = new System.Windows.Forms.Label();
			this.txtVnrm = new System.Windows.Forms.TextBox();
			this.txtVmax = new System.Windows.Forms.TextBox();
			this.txtDmax = new System.Windows.Forms.TextBox();
			this.lblVnrm = new System.Windows.Forms.Label();
			this.lblVmax = new System.Windows.Forms.Label();
			this.lblGmax = new System.Windows.Forms.Label();
			this.txtVmin = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.nudFPSize)).BeginInit();
			this.tbcSettings.SuspendLayout();
			this.tbpView.SuspendLayout();
			this.tbpConfig.SuspendLayout();
			this.tbpParameters.SuspendLayout();
			this.SuspendLayout();
			// 
			// pcbTracker
			// 
			this.pcbTracker.BackColor = System.Drawing.SystemColors.Window;
			this.pcbTracker.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pcbTracker.Location = new System.Drawing.Point(0, 0);
			this.pcbTracker.Name = "pcbTracker";
			this.pcbTracker.Size = new System.Drawing.Size(640, 480);
			this.pcbTracker.TabIndex = 0;
			this.pcbTracker.TabStop = false;
			this.pcbTracker.Paint += new System.Windows.Forms.PaintEventHandler(this.pcbTracker_Paint);
			// 
			// rdbViewXY
			// 
			this.rdbViewXY.Checked = true;
			this.rdbViewXY.Location = new System.Drawing.Point(8, 496);
			this.rdbViewXY.Name = "rdbViewXY";
			this.rdbViewXY.Size = new System.Drawing.Size(152, 24);
			this.rdbViewXY.TabIndex = 1;
			this.rdbViewXY.TabStop = true;
			this.rdbViewXY.Text = "XY-Darstellung";
			this.rdbViewXY.CheckedChanged += new System.EventHandler(this.rdbView_CheckedChanged);
			// 
			// rdbViewXT
			// 
			this.rdbViewXT.Location = new System.Drawing.Point(160, 496);
			this.rdbViewXT.Name = "rdbViewXT";
			this.rdbViewXT.Size = new System.Drawing.Size(152, 24);
			this.rdbViewXT.TabIndex = 2;
			this.rdbViewXT.Text = "XT-Darstellung";
			this.rdbViewXT.CheckedChanged += new System.EventHandler(this.rdbView_CheckedChanged);
			// 
			// rdbViewTY
			// 
			this.rdbViewTY.Location = new System.Drawing.Point(312, 496);
			this.rdbViewTY.Name = "rdbViewTY";
			this.rdbViewTY.Size = new System.Drawing.Size(152, 24);
			this.rdbViewTY.TabIndex = 3;
			this.rdbViewTY.Text = "TY-Darstellung";
			this.rdbViewTY.CheckedChanged += new System.EventHandler(this.rdbView_CheckedChanged);
			// 
			// lblSizeOfFP
			// 
			this.lblSizeOfFP.Location = new System.Drawing.Point(416, 120);
			this.lblSizeOfFP.Name = "lblSizeOfFP";
			this.lblSizeOfFP.Size = new System.Drawing.Size(186, 14);
			this.lblSizeOfFP.TabIndex = 29;
			this.lblSizeOfFP.Text = "Grsse der FP:";
			this.lblSizeOfFP.Visible = false;
			// 
			// nudFPSize
			// 
			this.nudFPSize.Location = new System.Drawing.Point(416, 136);
			this.nudFPSize.Minimum = new System.Decimal(new int[] {
																	  1,
																	  0,
																	  0,
																	  0});
			this.nudFPSize.Name = "nudFPSize";
			this.nudFPSize.Size = new System.Drawing.Size(66, 20);
			this.nudFPSize.TabIndex = 28;
			this.nudFPSize.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nudFPSize.Value = new System.Decimal(new int[] {
																	3,
																	0,
																	0,
																	0});
			this.nudFPSize.Visible = false;
			this.nudFPSize.ValueChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// lblNrOfFrames
			// 
			this.lblNrOfFrames.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblNrOfFrames.Location = new System.Drawing.Point(416, 96);
			this.lblNrOfFrames.Name = "lblNrOfFrames";
			this.lblNrOfFrames.Size = new System.Drawing.Size(133, 21);
			this.lblNrOfFrames.TabIndex = 24;
			this.lblNrOfFrames.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblNrOfFrames.Visible = false;
			// 
			// lblCurrentFrame
			// 
			this.lblCurrentFrame.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblCurrentFrame.Location = new System.Drawing.Point(416, 40);
			this.lblCurrentFrame.Name = "lblCurrentFrame";
			this.lblCurrentFrame.Size = new System.Drawing.Size(133, 21);
			this.lblCurrentFrame.TabIndex = 23;
			this.lblCurrentFrame.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblCurrentFrame.Visible = false;
			// 
			// lblNrOfFrameslbl
			// 
			this.lblNrOfFrameslbl.Location = new System.Drawing.Point(416, 72);
			this.lblNrOfFrameslbl.Name = "lblNrOfFrameslbl";
			this.lblNrOfFrameslbl.Size = new System.Drawing.Size(206, 14);
			this.lblNrOfFrameslbl.TabIndex = 22;
			this.lblNrOfFrameslbl.Text = "Anzahl gleichzeitig angezeigter Frames:";
			this.lblNrOfFrameslbl.Visible = false;
			// 
			// lblCurrentFramelbl
			// 
			this.lblCurrentFramelbl.Location = new System.Drawing.Point(416, 16);
			this.lblCurrentFramelbl.Name = "lblCurrentFramelbl";
			this.lblCurrentFramelbl.Size = new System.Drawing.Size(146, 14);
			this.lblCurrentFramelbl.TabIndex = 21;
			this.lblCurrentFramelbl.Text = "Aktuelles Zentralframe:";
			this.lblCurrentFramelbl.Visible = false;
			// 
			// btnPauseView
			// 
			this.btnPauseView.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnPauseView.Location = new System.Drawing.Point(656, 496);
			this.btnPauseView.Name = "btnPauseView";
			this.btnPauseView.Size = new System.Drawing.Size(168, 24);
			this.btnPauseView.TabIndex = 36;
			this.btnPauseView.Text = "Anzeige anhalten";
			this.btnPauseView.Click += new System.EventHandler(this.btnPauseView_Click);
			// 
			// btnContinueView
			// 
			this.btnContinueView.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnContinueView.Enabled = false;
			this.btnContinueView.Location = new System.Drawing.Point(656, 496);
			this.btnContinueView.Name = "btnContinueView";
			this.btnContinueView.Size = new System.Drawing.Size(168, 24);
			this.btnContinueView.TabIndex = 37;
			this.btnContinueView.Text = "Anzeige fortsetzen";
			this.btnContinueView.Visible = false;
			this.btnContinueView.Click += new System.EventHandler(this.btnContinueView_Click);
			// 
			// btnStopSource
			// 
			this.btnStopSource.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnStopSource.Enabled = false;
			this.btnStopSource.Location = new System.Drawing.Point(656, 472);
			this.btnStopSource.Name = "btnStopSource";
			this.btnStopSource.Size = new System.Drawing.Size(168, 24);
			this.btnStopSource.TabIndex = 39;
			this.btnStopSource.Text = "QuelleDeaktivieren";
			this.btnStopSource.Visible = false;
			this.btnStopSource.Click += new System.EventHandler(this.btnStopSource_Click);
			// 
			// btnStartSource
			// 
			this.btnStartSource.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnStartSource.Location = new System.Drawing.Point(656, 472);
			this.btnStartSource.Name = "btnStartSource";
			this.btnStartSource.Size = new System.Drawing.Size(168, 24);
			this.btnStartSource.TabIndex = 38;
			this.btnStartSource.Text = "Quelle aktivieren";
			this.btnStartSource.Click += new System.EventHandler(this.btnStartSource_Click);
			// 
			// rdbViewHypothesises
			// 
			this.rdbViewHypothesises.Location = new System.Drawing.Point(456, 496);
			this.rdbViewHypothesises.Name = "rdbViewHypothesises";
			this.rdbViewHypothesises.Size = new System.Drawing.Size(152, 24);
			this.rdbViewHypothesises.TabIndex = 40;
			this.rdbViewHypothesises.Text = "Hypothesen-Darstellung";
			this.rdbViewHypothesises.CheckedChanged += new System.EventHandler(this.rdbView_CheckedChanged);
			// 
			// tbcSettings
			// 
			this.tbcSettings.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbcSettings.Controls.Add(this.tbpView);
			this.tbcSettings.Controls.Add(this.tbpConfig);
			this.tbcSettings.Controls.Add(this.tbpParameters);
			this.tbcSettings.Location = new System.Drawing.Point(656, 8);
			this.tbcSettings.Name = "tbcSettings";
			this.tbcSettings.SelectedIndex = 0;
			this.tbcSettings.Size = new System.Drawing.Size(208, 456);
			this.tbcSettings.TabIndex = 41;
			// 
			// tbpView
			// 
			this.tbpView.Controls.Add(this.chkShowTrajectoryID);
			this.tbpView.Controls.Add(this.ckbMarkCurrentFrame);
			this.tbpView.Controls.Add(this.ckbShowFP);
			this.tbpView.Controls.Add(this.ckbShowTrajectories);
			this.tbpView.Controls.Add(this.chkShowCalculated);
			this.tbpView.Controls.Add(this.chkShowMeasured);
			this.tbpView.Controls.Add(this.ckbShowBlue);
			this.tbpView.Controls.Add(this.ckbShowGreen);
			this.tbpView.Controls.Add(this.ckbShowRed);
			this.tbpView.Location = new System.Drawing.Point(4, 22);
			this.tbpView.Name = "tbpView";
			this.tbpView.Size = new System.Drawing.Size(200, 430);
			this.tbpView.TabIndex = 0;
			this.tbpView.Text = "Ansicht";
			// 
			// chkShowTrajectoryID
			// 
			this.chkShowTrajectoryID.Checked = true;
			this.chkShowTrajectoryID.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowTrajectoryID.Location = new System.Drawing.Point(8, 8);
			this.chkShowTrajectoryID.Name = "chkShowTrajectoryID";
			this.chkShowTrajectoryID.Size = new System.Drawing.Size(208, 16);
			this.chkShowTrajectoryID.TabIndex = 48;
			this.chkShowTrajectoryID.Text = "TrajektorienID anzeigen";
			this.chkShowTrajectoryID.Visible = false;
			// 
			// ckbMarkCurrentFrame
			// 
			this.ckbMarkCurrentFrame.Location = new System.Drawing.Point(8, 32);
			this.ckbMarkCurrentFrame.Name = "ckbMarkCurrentFrame";
			this.ckbMarkCurrentFrame.Size = new System.Drawing.Size(208, 14);
			this.ckbMarkCurrentFrame.TabIndex = 47;
			this.ckbMarkCurrentFrame.Text = "FP des aktuellen Frames markieren";
			this.ckbMarkCurrentFrame.Visible = false;
			// 
			// ckbShowFP
			// 
			this.ckbShowFP.Location = new System.Drawing.Point(8, 56);
			this.ckbShowFP.Name = "ckbShowFP";
			this.ckbShowFP.Size = new System.Drawing.Size(208, 14);
			this.ckbShowFP.TabIndex = 46;
			this.ckbShowFP.Text = "Feature Punkte anzeigen";
			this.ckbShowFP.Visible = false;
			// 
			// ckbShowTrajectories
			// 
			this.ckbShowTrajectories.Location = new System.Drawing.Point(8, 80);
			this.ckbShowTrajectories.Name = "ckbShowTrajectories";
			this.ckbShowTrajectories.Size = new System.Drawing.Size(208, 14);
			this.ckbShowTrajectories.TabIndex = 45;
			this.ckbShowTrajectories.Text = "Trajektorien anzeigen";
			this.ckbShowTrajectories.Visible = false;
			// 
			// chkShowCalculated
			// 
			this.chkShowCalculated.Checked = true;
			this.chkShowCalculated.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowCalculated.Location = new System.Drawing.Point(8, 112);
			this.chkShowCalculated.Name = "chkShowCalculated";
			this.chkShowCalculated.Size = new System.Drawing.Size(208, 24);
			this.chkShowCalculated.TabIndex = 44;
			this.chkShowCalculated.Text = "Berechnete Punkte anzeigen";
			this.chkShowCalculated.Visible = false;
			// 
			// chkShowMeasured
			// 
			this.chkShowMeasured.Checked = true;
			this.chkShowMeasured.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowMeasured.Location = new System.Drawing.Point(8, 136);
			this.chkShowMeasured.Name = "chkShowMeasured";
			this.chkShowMeasured.Size = new System.Drawing.Size(208, 24);
			this.chkShowMeasured.TabIndex = 43;
			this.chkShowMeasured.Text = "Gemessene Punkte anzeigen";
			this.chkShowMeasured.Visible = false;
			// 
			// ckbShowBlue
			// 
			this.ckbShowBlue.Checked = true;
			this.ckbShowBlue.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowBlue.Location = new System.Drawing.Point(8, 224);
			this.ckbShowBlue.Name = "ckbShowBlue";
			this.ckbShowBlue.Size = new System.Drawing.Size(208, 24);
			this.ckbShowBlue.TabIndex = 36;
			this.ckbShowBlue.Text = "Blaue Punkte anzeigen";
			// 
			// ckbShowGreen
			// 
			this.ckbShowGreen.Checked = true;
			this.ckbShowGreen.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowGreen.Location = new System.Drawing.Point(8, 200);
			this.ckbShowGreen.Name = "ckbShowGreen";
			this.ckbShowGreen.Size = new System.Drawing.Size(208, 24);
			this.ckbShowGreen.TabIndex = 35;
			this.ckbShowGreen.Text = "Grne Punkte anzeigen";
			// 
			// ckbShowRed
			// 
			this.ckbShowRed.Checked = true;
			this.ckbShowRed.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowRed.Location = new System.Drawing.Point(8, 176);
			this.ckbShowRed.Name = "ckbShowRed";
			this.ckbShowRed.Size = new System.Drawing.Size(208, 24);
			this.ckbShowRed.TabIndex = 34;
			this.ckbShowRed.Text = "Rote Punkte anzeigen";
			// 
			// tbpConfig
			// 
			this.tbpConfig.Controls.Add(this.label1);
			this.tbpConfig.Controls.Add(this.lsbHypothesises);
			this.tbpConfig.Location = new System.Drawing.Point(4, 22);
			this.tbpConfig.Name = "tbpConfig";
			this.tbpConfig.Size = new System.Drawing.Size(200, 430);
			this.tbpConfig.TabIndex = 1;
			this.tbpConfig.Text = "Hypothesen";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(208, 16);
			this.label1.TabIndex = 1;
			// 
			// lsbHypothesises
			// 
			this.lsbHypothesises.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lsbHypothesises.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lsbHypothesises.ItemHeight = 14;
			this.lsbHypothesises.Location = new System.Drawing.Point(8, 24);
			this.lsbHypothesises.Name = "lsbHypothesises";
			this.lsbHypothesises.Size = new System.Drawing.Size(184, 368);
			this.lsbHypothesises.TabIndex = 0;
			// 
			// tbpParameters
			// 
			this.tbpParameters.Controls.Add(this.uOmega);
			this.tbpParameters.Controls.Add(this.lblVmin);
			this.tbpParameters.Controls.Add(this.txtVnrm);
			this.tbpParameters.Controls.Add(this.txtVmax);
			this.tbpParameters.Controls.Add(this.txtDmax);
			this.tbpParameters.Controls.Add(this.lblVnrm);
			this.tbpParameters.Controls.Add(this.lblVmax);
			this.tbpParameters.Controls.Add(this.lblGmax);
			this.tbpParameters.Controls.Add(this.txtVmin);
			this.tbpParameters.Location = new System.Drawing.Point(4, 22);
			this.tbpParameters.Name = "tbpParameters";
			this.tbpParameters.Size = new System.Drawing.Size(200, 430);
			this.tbpParameters.TabIndex = 2;
			this.tbpParameters.Text = "Parameter";
			// 
			// uOmega
			// 
			this.uOmega.AutoScroll = true;
			this.uOmega.Location = new System.Drawing.Point(16, 160);
			this.uOmega.Name = "uOmega";
			this.uOmega.Size = new System.Drawing.Size(176, 72);
			this.uOmega.TabIndex = 2;
			this.uOmega.Wa = 0.6F;
			this.uOmega.Wb = 0.4F;
			this.uOmega.Scroll += new MTClient.ScrollEventHandler(this.Parameters_Changed);
			// 
			// lblVmin
			// 
			this.lblVmin.Location = new System.Drawing.Point(16, 24);
			this.lblVmin.Name = "lblVmin";
			this.lblVmin.Size = new System.Drawing.Size(72, 16);
			this.lblVmin.TabIndex = 1;
			this.lblVmin.Text = "Vmin:";
			// 
			// txtVnrm
			// 
			this.txtVnrm.Location = new System.Drawing.Point(88, 56);
			this.txtVnrm.Name = "txtVnrm";
			this.txtVnrm.Size = new System.Drawing.Size(88, 20);
			this.txtVnrm.TabIndex = 0;
			this.txtVnrm.Text = "";
			this.txtVnrm.TextChanged += new System.EventHandler(this.Parameters_Changed);
			// 
			// txtVmax
			// 
			this.txtVmax.Location = new System.Drawing.Point(88, 88);
			this.txtVmax.Name = "txtVmax";
			this.txtVmax.Size = new System.Drawing.Size(88, 20);
			this.txtVmax.TabIndex = 0;
			this.txtVmax.Text = "";
			this.txtVmax.TextChanged += new System.EventHandler(this.Parameters_Changed);
			// 
			// txtDmax
			// 
			this.txtDmax.Location = new System.Drawing.Point(88, 120);
			this.txtDmax.Name = "txtDmax";
			this.txtDmax.Size = new System.Drawing.Size(88, 20);
			this.txtDmax.TabIndex = 0;
			this.txtDmax.Text = "";
			this.txtDmax.TextChanged += new System.EventHandler(this.Parameters_Changed);
			// 
			// lblVnrm
			// 
			this.lblVnrm.Location = new System.Drawing.Point(16, 56);
			this.lblVnrm.Name = "lblVnrm";
			this.lblVnrm.Size = new System.Drawing.Size(72, 16);
			this.lblVnrm.TabIndex = 1;
			this.lblVnrm.Text = "Vnrm:";
			// 
			// lblVmax
			// 
			this.lblVmax.Location = new System.Drawing.Point(16, 88);
			this.lblVmax.Name = "lblVmax";
			this.lblVmax.Size = new System.Drawing.Size(72, 16);
			this.lblVmax.TabIndex = 1;
			this.lblVmax.Text = "Vmax:";
			// 
			// lblGmax
			// 
			this.lblGmax.Location = new System.Drawing.Point(16, 120);
			this.lblGmax.Name = "lblGmax";
			this.lblGmax.Size = new System.Drawing.Size(72, 16);
			this.lblGmax.TabIndex = 1;
			this.lblGmax.Text = "dmax:";
			// 
			// txtVmin
			// 
			this.txtVmin.Location = new System.Drawing.Point(88, 24);
			this.txtVmin.Name = "txtVmin";
			this.txtVmin.Size = new System.Drawing.Size(88, 20);
			this.txtVmin.TabIndex = 0;
			this.txtVmin.Text = "";
			this.txtVmin.TextChanged += new System.EventHandler(this.Parameters_Changed);
			// 
			// uscTracker
			// 
			this.Controls.Add(this.tbcSettings);
			this.Controls.Add(this.rdbViewHypothesises);
			this.Controls.Add(this.btnStopSource);
			this.Controls.Add(this.btnStartSource);
			this.Controls.Add(this.btnContinueView);
			this.Controls.Add(this.btnPauseView);
			this.Controls.Add(this.lblSizeOfFP);
			this.Controls.Add(this.nudFPSize);
			this.Controls.Add(this.lblNrOfFrames);
			this.Controls.Add(this.lblCurrentFrame);
			this.Controls.Add(this.lblNrOfFrameslbl);
			this.Controls.Add(this.lblCurrentFramelbl);
			this.Controls.Add(this.rdbViewTY);
			this.Controls.Add(this.rdbViewXT);
			this.Controls.Add(this.rdbViewXY);
			this.Controls.Add(this.pcbTracker);
			this.Name = "uscTracker";
			this.Size = new System.Drawing.Size(872, 536);
			this.Load += new System.EventHandler(this.uscTracker_Load);
			((System.ComponentModel.ISupportInitialize)(this.nudFPSize)).EndInit();
			this.tbcSettings.ResumeLayout(false);
			this.tbpView.ResumeLayout(false);
			this.tbpConfig.ResumeLayout(false);
			this.tbpParameters.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		public void Initialize(clsTracker Tracker)
		{
			_Tracker = Tracker;

			//Connect Eventdelegates
			this._Tracker.NewFrame += new clsTracker.NewFrameDelegate(_Tracker_NewFrame);
			//			this._Tracker.ClosedConnection += new clsTracker.ClosedConnectionDelegate(_Tracker_ClosedConnection);

			_Tracker.Tracker.NewHypothesises +=new MT.Tracker.RGBTracker.NewHypothesisesDelegate(Tracker_NewHypothesises);

			//Update Form with all Tracker Parameters
			UpdateParameters();

		}
		private void SeedData()
		{
			//Lock GatherData
			//hsbFrame.Maximum = _data[0].CountFrames();
			_blnUpdating = true;

			//lblNrOfFrames.Text = nrOfFrames.ToString();
			//lblCurrentFrame.Text = currentFrame.ToString();
		
			nudFPSize.Value = _intFPSize;
			ckbShowFP.Checked = _blnShowFP;
			ckbMarkCurrentFrame.Checked = _blnMarkCurrentFrame;
			ckbShowTrajectories.Checked = _blnShowTrajectories;

			ckbShowRed.Checked = _blnShowRed;
			ckbShowGreen.Checked = _blnShowGreen;
			ckbShowBlue.Checked = _blnShowBlue;

			chkShowCalculated.Checked = _blnShowCalculated;
			chkShowMeasured.Checked = _blnShowMeasured;

			chkShowTrajectoryID.Checked = _blnShowTrajectoryID;
			
			pcbTracker.Refresh();

			_blnUpdating = false; 
		}

		private void GatherData()
		{
			if (!_blnUpdating)
			{
				//currentFrame = hsbFrame.Value;
				//nrOfFrames = trbNrOfFrames.Value;

				_intFPSize = int.Parse(nudFPSize.Value.ToString()) ;
				_blnShowFP = ckbShowFP.Checked;
				_blnMarkCurrentFrame = ckbMarkCurrentFrame.Checked ;
				_blnShowTrajectories = ckbShowTrajectories.Checked ;

				_blnShowRed = ckbShowRed.Checked;
				_blnShowGreen = ckbShowGreen.Checked;
				_blnShowBlue = ckbShowBlue.Checked;

				_blnShowCalculated= chkShowCalculated.Checked;
				_blnShowMeasured = chkShowMeasured.Checked;

				_blnShowTrajectoryID = chkShowTrajectoryID.Checked;


			}
		}

		/// <summary>
		/// This is a unifying procedure which handles all Value changing in any of its connected controls
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ctrl_newValue(object sender, System.EventArgs e)
		{
			GatherData();
			SeedData();
		}



		private void uscTracker_Closing(object sender, CancelEventArgs e)
		{

		}

		private void _Tracker_NewFrame(FeaturePointData Data)
		{
			_data = Data;
			pcbTracker.Refresh();
		}

		private void pcbTracker_Paint(object sender, PaintEventArgs e)
		{
			//Don't paint when tracker is inactive
			if (eState == enuTrackerState.inactive)
				return;
			
			//Dont draw nothing ;)
			if (_data == null)
				return;


			int nrOfFrames = _data.CountFrames();
			int currentFrame = nrOfFrames/2-2;

			int minframe = System.Math.Max(currentFrame-(nrOfFrames-1)/2,0);
			int maxframe = System.Math.Min(minframe +(nrOfFrames-1),_data.CountFrames());
			int i;
//			int j;
//			int k;
			float scaleX = (float)(e.ClipRectangle.Width)/nrOfFrames;
			float scaleY = (float)(e.ClipRectangle.Height)/nrOfFrames;;
			float scaleXY_X = (float)(e.ClipRectangle.Width/640.0);
			float scaleXY_Y = (float)(e.ClipRectangle.Height/480.0);


			//Console.Write(".");

			System.Drawing.Pen mypen_red = new Pen(Color.Red);
			System.Drawing.Pen mypen_blue = new Pen(Color.Blue);
			System.Drawing.Pen mypen_green = new Pen(Color.Green);
			System.Drawing.Pen mypen_white = new Pen(Color.Gray);
			System.Drawing.Pen mypen_standard = new Pen(Color.Black);
			System.Drawing.Pen mypen_transparent = new Pen(Color.Transparent);

			System.Drawing.Pen mypen= mypen_standard;

			Brush mybrush = Brushes.AliceBlue;

			try
			{

				foreach (FeaturePointFrame frame in _data.FeaturePointFrames.Values)
				{
					i = _data.FeaturePointFrames.IndexOfKey(frame.fid);

					foreach(FeaturePoint P in frame.Values)
						//for (j=0; j<frame.Count;j++)
					{
						switch (P.Color)
						{
							case eColorCode.R:
								if (_blnShowRed)
								{
									mypen = mypen_red;
									mybrush = System.Drawing.Brushes.Red;
								}
								else
								{
									mypen = mypen_transparent;
									mybrush = System.Drawing.Brushes.Transparent;
								}
								break;
							case eColorCode.B:
								if (_blnShowBlue)
								{
									mypen = mypen_blue;
									mybrush = System.Drawing.Brushes.Blue;
								}
								else
								{
									mypen = mypen_transparent;
									mybrush = System.Drawing.Brushes.Transparent;
								}
								break;
							case eColorCode.G:
								if (_blnShowGreen)
								{
									mypen = mypen_green;
									mybrush = System.Drawing.Brushes.Green;
								}
								else
								{
									mypen = mypen_transparent;
									mybrush = System.Drawing.Brushes.Transparent;
								}
								break;
//							case eColorCode.W:
//								mypen = mypen_standard;
//								mybrush = System.Drawing.Brushes.Gray;
//								break;
						}

						//Draw Trajectories if option is activated
						if (_blnShowTrajectories)
						{
							if ((P.Type == eFPType.measured && _blnShowMeasured) || (P.Type == eFPType.calculated && _blnShowCalculated))
								if (P.next !=null)
								{
									if (eState == enuTrackerState.XY)
										e.Graphics.DrawLine(mypen_standard,scaleXY_X*P.X,scaleXY_Y*P.Y,scaleXY_X*P.next.X,scaleXY_Y*P.next.Y);
									else if (eState == enuTrackerState.XT)
										e.Graphics.DrawLine(mypen_standard,scaleXY_X* P.X,scaleY*(i-minframe),scaleXY_X*P.next.X,scaleY*((i-minframe)+1));
									else if (eState == enuTrackerState.TY)
										e.Graphics.DrawLine(mypen_standard,scaleX*(i-minframe),scaleXY_Y*P.Y,scaleX*((i-minframe)+1),scaleXY_Y*P.next.Y);
								}
						}
							
						if (_blnShowTrajectoryID)
							if ((P.Type == eFPType.measured && _blnShowMeasured) || (P.Type == eFPType.calculated && _blnShowCalculated))
							{
								//Draw TrajectoryID
								if (i==currentFrame)
									if (eState == enuTrackerState.XY)
										e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleXY_X*P.X - _intFPSize/2 - 8,scaleXY_Y*P.Y - _intFPSize/2 -12);
									else if (eState == enuTrackerState.XT)
										e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleXY_X*P.X - _intFPSize/2 - 8,scaleY*(i-minframe) - _intFPSize/2 -12);
									else if (eState == enuTrackerState.TY)
										e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleX*(i-minframe)  - _intFPSize/2 - 8,scaleXY_Y*P.Y - _intFPSize/2 -12);
							}
						//Draw Featurepoint if option is activated
						if (_blnShowFP) 
						{
							if (P.Type == eFPType.measured && _blnShowMeasured)
							{
								if (eState == enuTrackerState.XY)
									e.Graphics.FillRectangle(mybrush,scaleXY_X*P.X - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
								else if (eState == enuTrackerState.XT)
									e.Graphics.FillRectangle(mybrush,scaleXY_X*P.X - _intFPSize/2, scaleY*(i-minframe) - _intFPSize/2,_intFPSize,_intFPSize); 
								else if (eState == enuTrackerState.TY)
									e.Graphics.FillRectangle(mybrush,scaleX*(i-minframe)  - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
							}
							else if(P.Type == eFPType.calculated && _blnShowCalculated)
							{
								if (eState == enuTrackerState.XY)
									e.Graphics.DrawRectangle(mypen,scaleXY_X*P.X - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
								else if (eState == enuTrackerState.XT)
									e.Graphics.DrawRectangle(mypen,scaleXY_X*P.X - _intFPSize/2, scaleY*(i-minframe) - _intFPSize/2,_intFPSize,_intFPSize); 
								else if (eState == enuTrackerState.TY)
									e.Graphics.DrawRectangle(mypen,scaleX*(i-minframe)  - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
							}
						}
	
						//Mark Featurepoints of current Frame if option is activated
						if (_blnMarkCurrentFrame) 
						{
							if (i==currentFrame)
							{

								if (eState == enuTrackerState.XY)
									e.Graphics.DrawRectangle(mypen_standard,scaleXY_X*P.X - (_intFPSize+2)/2, scaleXY_Y*P.Y - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
								else if (eState == enuTrackerState.XT)
									e.Graphics.DrawRectangle(mypen_standard,  scaleXY_X*P.X - (_intFPSize+2)/2, scaleY*(i-minframe) - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
								else if (eState == enuTrackerState.TY)
									e.Graphics.DrawRectangle(mypen_standard,scaleX*(i-minframe) - (_intFPSize+2)/2, scaleXY_Y*P.Y - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
							}					
						}
					}
				}
			}
			catch {}

		}

		private void uscTracker_Load(object sender, System.EventArgs e)
		{
		
		}

		private void rdbView_CheckedChanged(Object sender, System.EventArgs e)
		{
			RadioButton Sender = sender as RadioButton;
			if (Sender.Checked)
			{
				switch(Sender.Name)
				{
					case "rdbViewXY":
						eState = enuTrackerState.XY;
						_Tracker.Tracker.ConfigMode = false;
						break;
					case "rdbViewXT":
						eState = enuTrackerState.XT;
						_Tracker.Tracker.ConfigMode = false;
						break;
					case "rdbViewTY":
						eState = enuTrackerState.TY;
						_Tracker.Tracker.ConfigMode = false;

						break;
					case "rdbViewHypothesises":
						eState = enuTrackerState.Hypothesises;
						_Tracker.Tracker.ConfigMode = true;
						_Tracker.DoubleFrameCheck = false;
						break;
				}

				pcbTracker.Refresh();
			}
		
		}

		private void btnPauseView_Click(object sender, System.EventArgs e)
		{	
			//Disconnect NewFrame Event to prevent new views
			this._Tracker.NewFrame -= new clsTracker.NewFrameDelegate(_Tracker_NewFrame);
			btnPauseView.Enabled = false;
			btnPauseView.Visible = false;
			btnContinueView.Enabled = true;
			btnContinueView.Visible = true;
		}

		private void btnContinueView_Click(object sender, System.EventArgs e)
		{
			btnContinueView.Enabled = false;
			btnContinueView.Visible = false;
			btnPauseView.Enabled = true;
			btnPauseView.Visible = true;
	
			//Reconnect NewFrame Event to receive new views
			this._Tracker.NewFrame += new clsTracker.NewFrameDelegate(_Tracker_NewFrame);

		}

		private void btnStopSource_Click(object sender, System.EventArgs e)
		{
			btnStopSource.Enabled = false;
			btnStopSource.Visible = false;
			btnStartSource.Enabled = true;
			btnStartSource.Visible = true;

			_Tracker.DeactivateSource();
		}

		private void btnStartSource_Click(object sender, System.EventArgs e)
		{
			btnStartSource.Enabled = false;
			btnStartSource.Visible = false;
			btnStopSource.Enabled = true;
			btnStopSource.Visible = true;
	
			_Tracker.ActivateSource();

		}

		private void Tracker_NewHypothesises(HypothesisSuperSet HS_R, HypothesisSuperSet HS_G, HypothesisSuperSet HS_B)
		{
			lsbHypothesises.SuspendLayout();

			lsbHypothesises.Items.Clear();
			lsbHypothesises.Items.Add("Rote Hypothesen");
			lsbHypothesises.Items.Add("----------------");

			foreach (Hypothesis H in HS_R.Values)
			{
				lsbHypothesises.Items.Add(H);
			}

			lsbHypothesises.Items.Add("                ");

			lsbHypothesises.Items.Add("Grne Hypothesen");
			lsbHypothesises.Items.Add("----------------");

			foreach (Hypothesis H in HS_G.Values)
			{
				lsbHypothesises.Items.Add(H);
			}

			lsbHypothesises.Items.Add("                ");

			lsbHypothesises.Items.Add("Blaue Hypothesen");
			lsbHypothesises.Items.Add("----------------");

			foreach (Hypothesis H in HS_B.Values)
			{
				lsbHypothesises.Items.Add(H);
			}

			lsbHypothesises.ResumeLayout();
		}

		private void Parameters_Changed(object sender, System.EventArgs e)
		{
			lock(this)
			{
				if (!_updatingParameters)
				{
					try
					{
						_Tracker.Tracker.Vnrm =	int.Parse(txtVnrm.Text);
						_Tracker.Tracker.Vmin =	int.Parse(txtVmin.Text);
						_Tracker.Tracker.Vmax =	int.Parse(txtVmax.Text) ;
						_Tracker.Tracker.GammaMax = float.Parse(txtDmax.Text) ;
						_Tracker.Tracker.SpeedWeight = uOmega.Wa;  
						_Tracker.Tracker.AngleWeight = uOmega.Wb ;  
					}
					catch {}

				}
			}

		}

		private void UpdateParameters()
		{
			lock(this)
			{
				_updatingParameters = true;
			}

			txtVnrm.Text = _Tracker.Tracker.Vnrm.ToString();
			txtVmin.Text = _Tracker.Tracker.Vmin.ToString();
			txtVmax.Text = _Tracker.Tracker.Vmax.ToString();
			txtDmax.Text = _Tracker.Tracker.GammaMax.ToString();
			uOmega.Wa = _Tracker.Tracker.SpeedWeight;

			_updatingParameters = false;

		}



	}
}
