﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung für uscTrackerTrackbar.
	/// </summary>
	public class uscTrackerTrackbar : System.Windows.Forms.UserControl
	{

		private float _wa = 0.6f;
		private float _wb = 0.4f;

		public float Wa
		{
			get { return _wa; }
			set { setValue(Math.Max(Math.Min(1,value),0)); }
		}

		public float Wb
		{
			get { return _wb; }
			set { setValue(1- Math.Max(Math.Min(1,value),0)); }
		}

		private void setValue(float wa)
		{
			_wa = wa;
			_wb = 1-wa;

			TrackBar.Value = (int)(_wa*20);
			UpdateValues();
		}

		private void UpdateValues()
		{
			this.lblWaValue.Text = _wa.ToString();
			this.lblWbValue.Text = _wb.ToString();
		}

		private System.Windows.Forms.TrackBar TrackBar;
		private System.Windows.Forms.Label lblwa;
		private System.Windows.Forms.Label lblwb;
		private System.Windows.Forms.Label lblWaValue;
		private System.Windows.Forms.Label lblWbValue;
		/// <summary> 
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public uscTrackerTrackbar()
		{
			// Dieser Aufruf ist für den Windows Form-Designer erforderlich.
			InitializeComponent();

			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufügen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode für die Designerunterstützung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.TrackBar = new System.Windows.Forms.TrackBar();
			this.lblwa = new System.Windows.Forms.Label();
			this.lblwb = new System.Windows.Forms.Label();
			this.lblWaValue = new System.Windows.Forms.Label();
			this.lblWbValue = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.TrackBar)).BeginInit();
			this.SuspendLayout();
			// 
			// TrackBar
			// 
			this.TrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.TrackBar.Location = new System.Drawing.Point(0, 24);
			this.TrackBar.Maximum = 20;
			this.TrackBar.Name = "TrackBar";
			this.TrackBar.Size = new System.Drawing.Size(176, 42);
			this.TrackBar.TabIndex = 5;
			this.TrackBar.Value = 6;
			this.TrackBar.Scroll += new System.EventHandler(this.TrackBar_Scroll);
			// 
			// lblwa
			// 
			this.lblwa.Location = new System.Drawing.Point(8, 8);
			this.lblwa.Name = "lblwa";
			this.lblwa.Size = new System.Drawing.Size(32, 16);
			this.lblwa.TabIndex = 6;
			this.lblwa.Text = "ωa:";
			// 
			// lblwb
			// 
			this.lblwb.Location = new System.Drawing.Point(96, 8);
			this.lblwb.Name = "lblwb";
			this.lblwb.Size = new System.Drawing.Size(32, 16);
			this.lblwb.TabIndex = 4;
			this.lblwb.Text = "ωb:";
			// 
			// lblWaValue
			// 
			this.lblWaValue.Location = new System.Drawing.Point(40, 8);
			this.lblWaValue.Name = "lblWaValue";
			this.lblWaValue.Size = new System.Drawing.Size(48, 16);
			this.lblWaValue.TabIndex = 2;
			this.lblWaValue.Text = "0.6";
			// 
			// lblWbValue
			// 
			this.lblWbValue.Location = new System.Drawing.Point(128, 8);
			this.lblWbValue.Name = "lblWbValue";
			this.lblWbValue.Size = new System.Drawing.Size(48, 16);
			this.lblWbValue.TabIndex = 3;
			this.lblWbValue.Text = "0.4";
			// 
			// uscTrackerTrackbar
			// 
			this.AutoScroll = true;
			this.Controls.Add(this.TrackBar);
			this.Controls.Add(this.lblwa);
			this.Controls.Add(this.lblwb);
			this.Controls.Add(this.lblWaValue);
			this.Controls.Add(this.lblWbValue);
			this.Name = "uscTrackerTrackbar";
			this.Size = new System.Drawing.Size(176, 72);
			((System.ComponentModel.ISupportInitialize)(this.TrackBar)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void TrackBar_Scroll(object sender, System.EventArgs e)
		{
			TrackBar myTB = sender as TrackBar;
			
			_wa = (float)myTB.Value/20.0f;
			_wb = 1-_wa;

			UpdateValues();

			if (Scroll!=null) {Scroll(this,new ScrollEventArgs(_wa,_wb));}

		}

		public event ScrollEventHandler Scroll;
	}

	public delegate void ScrollEventHandler(object sender, EventArgs e);

	public class ScrollEventArgs: EventArgs
	{

		private float _wa;
		private float _wb;


		public float Wa
		{
			get { return _wa; }
		}

		public float Wb
		{
			get { return _wb; }
		}

		public ScrollEventArgs(float wa, float wb)
		{
			_wa = wa;
			_wb = wb;
		}
	}
}
