using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using GraphController;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr uscVideo.
	/// </summary>
	public class uscVideo : System.Windows.Forms.UserControl
	{
		//declare Event Delegates
		public delegate void NewFrameRateDelegate(string message);
		public delegate void NewResolutionDelegate(string message);


		//declare Events
		public event NewFrameRateDelegate NewFrameRate;
		public event NewResolutionDelegate NewResolution;

		protected clsVideo		_Video;
		protected int				_defBrightness;
		protected int				_defContrast;
		protected int				_defSaturation;
		protected int				_defGamma;
		protected int             _defGain;
		protected int             _defWhiteBalance;
		protected int             _defColorEnable;
		protected int             _defBacklightCompensation;
		protected FilterGraphController _filterGraphController;

		protected const int WM_GRAPHNOTIFY	= 0x00008001;	// message from graph

		protected System.Windows.Forms.CheckBox ckbOnOff;
		protected System.Windows.Forms.GroupBox grpBild;
		protected System.Windows.Forms.Label lblBrightness;
		protected System.Windows.Forms.Label lblContrast;
		protected System.Windows.Forms.Label lblSaturation;
		protected System.Windows.Forms.Label lblGamma;
		protected System.Windows.Forms.TrackBar trackBrightness;
		protected System.Windows.Forms.TrackBar trackContrast;
		protected System.Windows.Forms.TrackBar trackGamma;
		protected System.Windows.Forms.TrackBar trackSaturation;
		protected System.Windows.Forms.Button btnDefault;
		protected System.Windows.Forms.Panel videoPanel;
		protected System.Windows.Forms.GroupBox grpStandard;
		protected System.Windows.Forms.ListBox lstProperties;
		protected System.Windows.Forms.Label lblProperties;
		protected System.Windows.Forms.GroupBox grpPictureMode;
		protected System.Windows.Forms.CheckBox chkColorEnable;
		protected System.Windows.Forms.CheckBox chkBacklight;
		protected System.Windows.Forms.CheckBox chkHorizontal;
		protected System.Windows.Forms.CheckBox chkVertical;
		protected System.Windows.Forms.Label lblFramerate;
		protected System.Windows.Forms.Label lblResolution;
		protected System.Windows.Forms.GroupBox grpShow;
		protected System.Windows.Forms.ComboBox cmbResolution;
		protected System.Windows.Forms.ComboBox cmbFramerate;
		protected System.ComponentModel.IContainer components;

		public uscVideo()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();
			


			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.ckbOnOff = new System.Windows.Forms.CheckBox();
			this.grpBild = new System.Windows.Forms.GroupBox();
			this.lblSaturation = new System.Windows.Forms.Label();
			this.lblGamma = new System.Windows.Forms.Label();
			this.lblContrast = new System.Windows.Forms.Label();
			this.lblBrightness = new System.Windows.Forms.Label();
			this.trackGamma = new System.Windows.Forms.TrackBar();
			this.trackContrast = new System.Windows.Forms.TrackBar();
			this.trackBrightness = new System.Windows.Forms.TrackBar();
			this.trackSaturation = new System.Windows.Forms.TrackBar();
			this.grpPictureMode = new System.Windows.Forms.GroupBox();
			this.chkVertical = new System.Windows.Forms.CheckBox();
			this.chkHorizontal = new System.Windows.Forms.CheckBox();
			this.chkBacklight = new System.Windows.Forms.CheckBox();
			this.chkColorEnable = new System.Windows.Forms.CheckBox();
			this.grpStandard = new System.Windows.Forms.GroupBox();
			this.btnDefault = new System.Windows.Forms.Button();
			this.lstProperties = new System.Windows.Forms.ListBox();
			this.lblProperties = new System.Windows.Forms.Label();
			this.videoPanel = new System.Windows.Forms.Panel();
			this.lblFramerate = new System.Windows.Forms.Label();
			this.lblResolution = new System.Windows.Forms.Label();
			this.grpShow = new System.Windows.Forms.GroupBox();
			this.cmbResolution = new System.Windows.Forms.ComboBox();
			this.cmbFramerate = new System.Windows.Forms.ComboBox();
			this.grpBild.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackGamma)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackContrast)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBrightness)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackSaturation)).BeginInit();
			this.grpPictureMode.SuspendLayout();
			this.grpStandard.SuspendLayout();
			this.grpShow.SuspendLayout();
			this.SuspendLayout();
			// 
			// ckbOnOff
			// 
			this.ckbOnOff.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbOnOff.Checked = true;
			this.ckbOnOff.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOnOff.Location = new System.Drawing.Point(12, 20);
			this.ckbOnOff.Name = "ckbOnOff";
			this.ckbOnOff.Size = new System.Drawing.Size(252, 15);
			this.ckbOnOff.TabIndex = 3;
			this.ckbOnOff.Text = "ein/ausschalten";
			this.ckbOnOff.CheckedChanged += new System.EventHandler(this.ckbOnOff_CheckedChanged);
			// 
			// grpBild
			// 
			this.grpBild.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpBild.Controls.Add(this.lblSaturation);
			this.grpBild.Controls.Add(this.lblGamma);
			this.grpBild.Controls.Add(this.lblContrast);
			this.grpBild.Controls.Add(this.lblBrightness);
			this.grpBild.Controls.Add(this.trackGamma);
			this.grpBild.Controls.Add(this.trackContrast);
			this.grpBild.Controls.Add(this.trackBrightness);
			this.grpBild.Controls.Add(this.trackSaturation);
			this.grpBild.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.grpBild.Location = new System.Drawing.Point(648, 54);
			this.grpBild.Name = "grpBild";
			this.grpBild.Size = new System.Drawing.Size(280, 128);
			this.grpBild.TabIndex = 5;
			this.grpBild.TabStop = false;
			this.grpBild.Text = "Bildqualitt";
			// 
			// lblSaturation
			// 
			this.lblSaturation.Location = new System.Drawing.Point(8, 101);
			this.lblSaturation.Name = "lblSaturation";
			this.lblSaturation.Size = new System.Drawing.Size(88, 23);
			this.lblSaturation.TabIndex = 15;
			this.lblSaturation.Text = "Sttigung";
			this.lblSaturation.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// lblGamma
			// 
			this.lblGamma.Location = new System.Drawing.Point(8, 74);
			this.lblGamma.Name = "lblGamma";
			this.lblGamma.Size = new System.Drawing.Size(88, 23);
			this.lblGamma.TabIndex = 14;
			this.lblGamma.Text = "Gammakorektur";
			this.lblGamma.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// lblContrast
			// 
			this.lblContrast.Location = new System.Drawing.Point(8, 47);
			this.lblContrast.Name = "lblContrast";
			this.lblContrast.Size = new System.Drawing.Size(88, 23);
			this.lblContrast.TabIndex = 13;
			this.lblContrast.Text = "Kontrast";
			this.lblContrast.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// lblBrightness
			// 
			this.lblBrightness.Location = new System.Drawing.Point(8, 20);
			this.lblBrightness.Name = "lblBrightness";
			this.lblBrightness.Size = new System.Drawing.Size(88, 23);
			this.lblBrightness.TabIndex = 12;
			this.lblBrightness.Text = "Helligkeit";
			this.lblBrightness.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// trackGamma
			// 
			this.trackGamma.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.trackGamma.AutoSize = false;
			this.trackGamma.Location = new System.Drawing.Point(102, 74);
			this.trackGamma.Maximum = 31;
			this.trackGamma.Name = "trackGamma";
			this.trackGamma.Size = new System.Drawing.Size(168, 20);
			this.trackGamma.TabIndex = 10;
			this.trackGamma.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackGamma.Scroll += new System.EventHandler(this.trackGamma_Scroll);
			// 
			// trackContrast
			// 
			this.trackContrast.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.trackContrast.AutoSize = false;
			this.trackContrast.Location = new System.Drawing.Point(102, 47);
			this.trackContrast.Maximum = 63;
			this.trackContrast.Name = "trackContrast";
			this.trackContrast.Size = new System.Drawing.Size(168, 20);
			this.trackContrast.TabIndex = 9;
			this.trackContrast.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackContrast.Scroll += new System.EventHandler(this.trackContrast_Scroll);
			// 
			// trackBrightness
			// 
			this.trackBrightness.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.trackBrightness.AutoSize = false;
			this.trackBrightness.Location = new System.Drawing.Point(102, 20);
			this.trackBrightness.Maximum = 127;
			this.trackBrightness.Name = "trackBrightness";
			this.trackBrightness.Size = new System.Drawing.Size(168, 20);
			this.trackBrightness.TabIndex = 8;
			this.trackBrightness.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBrightness.Scroll += new System.EventHandler(this.trackBrightness_Scroll);
			// 
			// trackSaturation
			// 
			this.trackSaturation.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.trackSaturation.AutoSize = false;
			this.trackSaturation.Location = new System.Drawing.Point(102, 101);
			this.trackSaturation.Maximum = 100;
			this.trackSaturation.Minimum = -100;
			this.trackSaturation.Name = "trackSaturation";
			this.trackSaturation.Size = new System.Drawing.Size(168, 20);
			this.trackSaturation.TabIndex = 11;
			this.trackSaturation.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackSaturation.Scroll += new System.EventHandler(this.trackSaturation_Scroll);
			// 
			// grpPictureMode
			// 
			this.grpPictureMode.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpPictureMode.Controls.Add(this.chkVertical);
			this.grpPictureMode.Controls.Add(this.chkHorizontal);
			this.grpPictureMode.Controls.Add(this.chkBacklight);
			this.grpPictureMode.Controls.Add(this.chkColorEnable);
			this.grpPictureMode.Location = new System.Drawing.Point(648, 194);
			this.grpPictureMode.Name = "grpPictureMode";
			this.grpPictureMode.Size = new System.Drawing.Size(280, 70);
			this.grpPictureMode.TabIndex = 16;
			this.grpPictureMode.TabStop = false;
			this.grpPictureMode.Text = "Bildmodi";
			// 
			// chkVertical
			// 
			this.chkVertical.Location = new System.Drawing.Point(144, 43);
			this.chkVertical.Name = "chkVertical";
			this.chkVertical.TabIndex = 19;
			this.chkVertical.Text = "Vertikal";
			this.chkVertical.CheckedChanged += new System.EventHandler(this.chkVertical_CheckedChanged);
			// 
			// chkHorizontal
			// 
			this.chkHorizontal.Location = new System.Drawing.Point(144, 19);
			this.chkHorizontal.Name = "chkHorizontal";
			this.chkHorizontal.TabIndex = 18;
			this.chkHorizontal.Text = "Horizontal";
			this.chkHorizontal.CheckedChanged += new System.EventHandler(this.chkHorizontal_CheckedChanged);
			// 
			// chkBacklight
			// 
			this.chkBacklight.Location = new System.Drawing.Point(16, 43);
			this.chkBacklight.Name = "chkBacklight";
			this.chkBacklight.TabIndex = 17;
			this.chkBacklight.Text = "Gegenlicht";
			this.chkBacklight.CheckedChanged += new System.EventHandler(this.chkBacklight_CheckedChanged);
			// 
			// chkColorEnable
			// 
			this.chkColorEnable.Location = new System.Drawing.Point(16, 19);
			this.chkColorEnable.Name = "chkColorEnable";
			this.chkColorEnable.TabIndex = 16;
			this.chkColorEnable.Text = "Schwarzweiss";
			this.chkColorEnable.CheckedChanged += new System.EventHandler(this.chkColorEnable_CheckedChanged);
			// 
			// grpStandard
			// 
			this.grpStandard.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.grpStandard.Controls.Add(this.btnDefault);
			this.grpStandard.Location = new System.Drawing.Point(792, 432);
			this.grpStandard.Name = "grpStandard";
			this.grpStandard.Size = new System.Drawing.Size(136, 48);
			this.grpStandard.TabIndex = 18;
			this.grpStandard.TabStop = false;
			this.grpStandard.Text = "Standardeinstellungen";
			// 
			// btnDefault
			// 
			this.btnDefault.Location = new System.Drawing.Point(16, 16);
			this.btnDefault.Name = "btnDefault";
			this.btnDefault.Size = new System.Drawing.Size(104, 23);
			this.btnDefault.TabIndex = 0;
			this.btnDefault.Text = "Wiederherstellen";
			this.btnDefault.Click += new System.EventHandler(this.btnDefault_Click);
			// 
			// lstProperties
			// 
			this.lstProperties.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstProperties.Location = new System.Drawing.Point(728, 284);
			this.lstProperties.Name = "lstProperties";
			this.lstProperties.Size = new System.Drawing.Size(200, 69);
			this.lstProperties.TabIndex = 19;
			this.lstProperties.SelectedIndexChanged += new System.EventHandler(this.lstProperties_SelectedIndexChanged);
			// 
			// lblProperties
			// 
			this.lblProperties.Location = new System.Drawing.Point(648, 284);
			this.lblProperties.Name = "lblProperties";
			this.lblProperties.Size = new System.Drawing.Size(80, 16);
			this.lblProperties.TabIndex = 20;
			this.lblProperties.Text = "Eigenschaften:";
			this.lblProperties.Click += new System.EventHandler(this.lblProperties_Click);
			// 
			// videoPanel
			// 
			this.videoPanel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.videoPanel.Location = new System.Drawing.Point(0, 0);
			this.videoPanel.Name = "videoPanel";
			this.videoPanel.Size = new System.Drawing.Size(640, 480);
			this.videoPanel.TabIndex = 21;
			// 
			// lblFramerate
			// 
			this.lblFramerate.Location = new System.Drawing.Point(648, 380);
			this.lblFramerate.Name = "lblFramerate";
			this.lblFramerate.Size = new System.Drawing.Size(64, 16);
			this.lblFramerate.TabIndex = 33;
			this.lblFramerate.Text = "Framerate:";
			// 
			// lblResolution
			// 
			this.lblResolution.Location = new System.Drawing.Point(648, 356);
			this.lblResolution.Name = "lblResolution";
			this.lblResolution.Size = new System.Drawing.Size(64, 16);
			this.lblResolution.TabIndex = 31;
			this.lblResolution.Text = "Auflsung:";
			// 
			// grpShow
			// 
			this.grpShow.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpShow.Controls.Add(this.ckbOnOff);
			this.grpShow.Location = new System.Drawing.Point(648, 0);
			this.grpShow.Name = "grpShow";
			this.grpShow.Size = new System.Drawing.Size(280, 48);
			this.grpShow.TabIndex = 34;
			this.grpShow.TabStop = false;
			this.grpShow.Text = "Anzeige";
			// 
			// cmbResolution
			// 
			this.cmbResolution.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbResolution.Location = new System.Drawing.Point(728, 356);
			this.cmbResolution.Name = "cmbResolution";
			this.cmbResolution.Size = new System.Drawing.Size(200, 21);
			this.cmbResolution.TabIndex = 35;
			this.cmbResolution.Text = "None";
			this.cmbResolution.SelectedIndexChanged += new System.EventHandler(this.cmbResolution_SelectedIndexChanged);
			// 
			// cmbFramerate
			// 
			this.cmbFramerate.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbFramerate.Location = new System.Drawing.Point(728, 380);
			this.cmbFramerate.Name = "cmbFramerate";
			this.cmbFramerate.Size = new System.Drawing.Size(200, 21);
			this.cmbFramerate.TabIndex = 36;
			this.cmbFramerate.Text = "None";
			this.cmbFramerate.SelectedIndexChanged += new System.EventHandler(this.cmbFramerate_SelectedIndexChanged);
			// 
			// uscVideo
			// 
			this.Controls.Add(this.cmbFramerate);
			this.Controls.Add(this.cmbResolution);
			this.Controls.Add(this.lblFramerate);
			this.Controls.Add(this.lblResolution);
			this.Controls.Add(this.videoPanel);
			this.Controls.Add(this.lblProperties);
			this.Controls.Add(this.lstProperties);
			this.Controls.Add(this.grpBild);
			this.Controls.Add(this.grpPictureMode);
			this.Controls.Add(this.grpStandard);
			this.Controls.Add(this.grpShow);
			this.Name = "uscVideo";
			this.Size = new System.Drawing.Size(936, 488);
			this.grpBild.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackGamma)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackContrast)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBrightness)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackSaturation)).EndInit();
			this.grpPictureMode.ResumeLayout(false);
			this.grpStandard.ResumeLayout(false);
			this.grpShow.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		


		public void Initalize(FilterGraphController filterGraphController, Filters filters)
		{
			PropertyPage p;
			
			_filterGraphController = filterGraphController;
			_Video = new clsVideo(_filterGraphController,filters,this.videoPanel);

			try
			{
				if ( _filterGraphController.PreviewWindow == null )
					_filterGraphController.PreviewWindow = this.videoPanel;
			}
			catch (Exception ex)
			{ 
				Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
			

			// Load property pages
			try
			{
				lstProperties.Items.Clear();
				for ( int c = 0; c < _filterGraphController.PropertyPages.Count; c++ )
				{
					p = _filterGraphController.PropertyPages[c];
					lstProperties.Items.Add(p.Name + "...");
				}
			}
			catch { }

			setValues();

		}

		virtual public void setValues()
		{
			// Load frame sizes
			try
			{
				SortedList s;
				cmbResolution.Items.Clear();
				Size frameSize = _filterGraphController.FrameSize;
				int Width = frameSize.Width;
				int Height =  frameSize.Height;
				s = _filterGraphController.getResolutionCaps();

				cmbResolution.Text =  Width + " x " + Height;

				if(NewResolution!= null)
					NewResolution("Auflsung: " + Width + " x " + Height);

				foreach(Size cursize in s.Values)
				{
					cmbResolution.Items.Add(cursize.Width + " x " + cursize.Height);
					cmbResolution.SelectedItem = ( frameSize == new Size( cursize.Width, cursize.Height ) );
				}
				
			}
			catch { }

			// Load frame rates
			try
			{
				cmbFramerate.Items.Clear();
				int frameRate = (int) (_filterGraphController.FrameRate * 1000);
				int useframeRate =frameRate/1000;
				if(NewFrameRate != null)
					NewFrameRate("Frame Rate: " + useframeRate + " fps");

				cmbFramerate.Items.Add("5 fps");
				cmbFramerate.SelectedItem = ( frameRate == 5000 );
				
				cmbFramerate.Items.Add("10 fps");
				cmbFramerate.SelectedItem = ( frameRate == 10000 );

				cmbFramerate.Items.Add("15 fps");
				cmbFramerate.SelectedItem = ( frameRate == 15000 );

				cmbFramerate.Items.Add("24 fps (Film)");
				cmbFramerate.SelectedItem = ( frameRate == 24000 );
				
				cmbFramerate.Items.Add("25 fps (PAL)");
				cmbFramerate.SelectedItem = ( frameRate == 25000 );

				cmbFramerate.Items.Add("29.997 fps (NTSC)");
				cmbFramerate.SelectedItem = ( frameRate == 29997 );

				cmbFramerate.Items.Add( "30 fps (~NTSC)");
				cmbFramerate.SelectedItem = ( frameRate == 30000 );

//				cmbFramerate.Items.Add( "59.994 fps (2xNTSC)");
//				cmbFramerate.SelectedItem = ( frameRate == 59994  );

				cmbFramerate.Text = useframeRate + " fps";
			}
			catch {}

			int min, max, step, pdefault;
			_Video.getPropertyRange(clsVideo.videoProp.Brightness, out min, out max, out step, out pdefault);
			this.trackBrightness.Maximum = max;
			this.trackBrightness.Minimum  = min;
			this.trackBrightness.TickFrequency = step;
			_defBrightness = pdefault;
            this.trackBrightness.Value = _Video.Brightness;

			_Video.getPropertyRange(clsVideo.videoProp.Contrast, out min, out max, out step, out pdefault);
			this.trackContrast.Maximum = max;
			this.trackContrast.Minimum  = min;
			this.trackContrast.TickFrequency = step;
			_defContrast = pdefault;
			this.trackContrast.Value = _Video.Contrast;

			_Video.getPropertyRange(clsVideo.videoProp.Saturation, out min, out max, out step, out pdefault);
			this.trackSaturation.Maximum = max;
			this.trackSaturation.Minimum  = min;
			this.trackSaturation.TickFrequency = step;
			_defSaturation = pdefault;
			this.trackSaturation.Value = _Video.Saturation;

			_Video.getPropertyRange(clsVideo.videoProp.Gamma, out min, out max, out step, out pdefault);
			this.trackGamma.Maximum = max;
			this.trackGamma.Minimum  = min;
			this.trackGamma.TickFrequency = step;
			_defGamma = pdefault;
			this.trackGamma.Value = _Video.Gamma;

			_Video.getPropertyRange(clsVideo.videoProp.ColorEnable, out min, out max, out step, out pdefault);
//			this.chkColorEnable.Maximum = max;
//			this.trackGain.Minimum  = min;
//			this.trackGain.TickFrequency = step;
			_defColorEnable = pdefault;
			if(_Video.ColorEnable ==255)
			{
				this.chkColorEnable.Checked = false;
			}
			else
			{
				this.chkColorEnable.Checked = true;
			}

			_Video.getPropertyRange(clsVideo.videoProp.BacklightCompensation, out min, out max, out step, out pdefault);
//			this.trackShutter.Maximum = max;
//			this.trackShutter.Minimum  = min;
//			this.trackShutter.TickFrequency = step;
			_defBacklightCompensation = pdefault;
			if(_Video.BacklightCompensation==255)
			{
				this.chkBacklight.Checked = true;
			}
			else
			{
				this.chkBacklight.Checked = false;
			}

			
		}


		private void trackBrightness_Scroll(object sender, System.EventArgs e)
		{
			_Video.Brightness = this.trackBrightness.Value;
		
		}

		private void trackContrast_Scroll(object sender, System.EventArgs e)
		{
			_Video.Contrast = this.trackContrast.Value;
		}

		private void trackGamma_Scroll(object sender, System.EventArgs e)
		{
			_Video.Gamma  = this.trackGamma.Value;
		}

		private void trackSaturation_Scroll(object sender, System.EventArgs e)
		{
			_Video.Saturation = this.trackSaturation.Value;
		}

		private void ckbOnOff_CheckedChanged(object sender, System.EventArgs e)
		{
			_Video.ckbOnOff = this.ckbOnOff.Checked;
		}

		private void btnPropPrev_Click(object sender, System.EventArgs e)
		{
			_Video.Property(1);
		}

		private void btnPropCap_Click(object sender, System.EventArgs e)
		{
			_Video.Property(2);
		}

		private void btnPropTrans_Click(object sender, System.EventArgs e)
		{
			_Video.Property(3);
		}

		private void btnDefault_Click(object sender, System.EventArgs e)
		{

			_Video.Brightness = _defBrightness;
			_Video.Contrast = _defContrast;
			_Video.Saturation = _defSaturation;
			_Video.Gamma = _defGamma;
			_Video.Gain = _defGain;
			_Video.ColorEnable   = _defColorEnable;
			_Video.BacklightCompensation  = _defBacklightCompensation;

			this.trackBrightness.Value = _Video.Brightness;
			this.trackContrast.Value = _Video.Contrast;
			this.trackSaturation.Value = _Video.Saturation;
			this.trackGamma.Value = _Video.Gamma;
			this.chkColorEnable.Checked = false;
			this.chkBacklight.Checked = false;
		}


		private void lstProperties_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				ListBox m = sender as ListBox;
				_filterGraphController.PropertyPages[m.SelectedIndex].Show( this );
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Unable display property page. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}

		private void chkColorEnable_CheckedChanged(object sender, System.EventArgs e)
		{
			if(_Video.ColorEnable ==255)
			{
				this.chkColorEnable.Checked = true;
				_Video.ColorEnable = 0;
			}
			else
			{
				this.chkColorEnable.Checked = false;
				_Video.ColorEnable = 255;
			}
		}

		private void chkBacklight_CheckedChanged(object sender, System.EventArgs e)
		{
			if(_Video.BacklightCompensation==0)
			{
				this.chkBacklight.Checked = true;
				_Video.BacklightCompensation = 255;
			}
			else
			{
				this.chkBacklight.Checked = false;
				_Video.BacklightCompensation = 0;
			}
		
		}

		private void chkHorizontal_CheckedChanged(object sender, System.EventArgs e)
		{
			_Video.FlipHorizontal();
		
		}

		private void chkVertical_CheckedChanged(object sender, System.EventArgs e)
		{
			_Video.FlipVertical();
		}


		private void cmbResolution_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				// Update the frame size
				ComboBox m = sender as ComboBox;
				string[] s = m.Text.Split( 'x' );
				Size size = new Size( int.Parse( s[0] ), int.Parse( s[1] ) );
				_filterGraphController.setResolution(size);

				Size frameSize = _filterGraphController.FrameSize;
				if(NewResolution!= null)
					NewResolution("Auflsung: " + frameSize.Width + " x " + frameSize.Height);



				
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Frame size not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}

		private void cmbFramerate_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				ComboBox m = sender as ComboBox;
				string[] s = m.Text.Split( ' ' );
				_filterGraphController.setFramerate(double.Parse( s[0] ));

				int frameRate = (int) (_filterGraphController.FrameRate);
				if(NewFrameRate != null)
					NewFrameRate("Frame Rate: " + frameRate + " fps");
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Frame rate not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}

		private void lblProperties_Click(object sender, System.EventArgs e)
		{
		
		}

		public Control PreviewWindow
		{
			get
			{
				return this.videoPanel;
			}
		}



	
	}
}
