using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using GraphController;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr uscVideo.
	/// </summary>
	public class uscVideoFile : System.Windows.Forms.UserControl
	{
		//declare Event Delegates
		public delegate void NewFrameRateDelegate(string message);
		public delegate void NewResolutionDelegate(string message);


		//declare Events
//		public event NewFrameRateDelegate NewFrameRate;
//		public event NewResolutionDelegate NewResolution;

		protected FilterGraphControllerSource _filterGraphControllerSource;
		private bool								_OnOff;
		private Filters								_filters;
		private const string clipFileFilters =
			"Video Files (avi qt mov mpg mpeg m1v)|*.avi;*.qt;*.mov;*.mpg;*.mpeg;*.m1v|" +
			"All Files (*.*)|*.*";

		protected const int WM_GRAPHNOTIFY	= 0x00008001;
		protected System.Windows.Forms.Panel videoPanel;
		private System.Windows.Forms.ImageList imageList1;
		protected System.Windows.Forms.Label lblProperties;
		protected System.Windows.Forms.ListBox lstProperties;
		protected System.Windows.Forms.GroupBox grpShow;
		protected System.Windows.Forms.CheckBox ckbOnOff;
		protected System.Windows.Forms.ToolBar toolBarControl;
		protected System.Windows.Forms.ToolBarButton tbtnPlay;
		protected System.Windows.Forms.ToolBarButton tbtnPause;
		protected System.Windows.Forms.ToolBarButton tbtnStop;
		protected System.Windows.Forms.ToolBarButton tbtnDirectory;
		protected System.Windows.Forms.ToolBarButton tbtnFS;
		protected System.Windows.Forms.TrackBar trackVideo;
		protected System.Windows.Forms.StatusBar stbVideo;
		protected System.Windows.Forms.StatusBarPanel stbStatus;
		protected System.Windows.Forms.StatusBarPanel stbFrame;
		protected System.Windows.Forms.StatusBarPanel stbTime;
		protected System.Windows.Forms.StatusBarPanel stbTimeLen;
		private System.Windows.Forms.Timer timerUpdateInfo;
		protected System.Windows.Forms.Label label1;
		protected System.Windows.Forms.ListBox lstAudio;
		private System.ComponentModel.IContainer components;

		public uscVideoFile()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();
			


			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(uscVideoFile));
			this.videoPanel = new System.Windows.Forms.Panel();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.trackVideo = new System.Windows.Forms.TrackBar();
			this.toolBarControl = new System.Windows.Forms.ToolBar();
			this.tbtnPlay = new System.Windows.Forms.ToolBarButton();
			this.tbtnPause = new System.Windows.Forms.ToolBarButton();
			this.tbtnStop = new System.Windows.Forms.ToolBarButton();
			this.tbtnDirectory = new System.Windows.Forms.ToolBarButton();
			this.tbtnFS = new System.Windows.Forms.ToolBarButton();
			this.stbVideo = new System.Windows.Forms.StatusBar();
			this.stbStatus = new System.Windows.Forms.StatusBarPanel();
			this.stbFrame = new System.Windows.Forms.StatusBarPanel();
			this.stbTime = new System.Windows.Forms.StatusBarPanel();
			this.stbTimeLen = new System.Windows.Forms.StatusBarPanel();
			this.lblProperties = new System.Windows.Forms.Label();
			this.lstProperties = new System.Windows.Forms.ListBox();
			this.grpShow = new System.Windows.Forms.GroupBox();
			this.ckbOnOff = new System.Windows.Forms.CheckBox();
			this.timerUpdateInfo = new System.Windows.Forms.Timer(this.components);
			this.label1 = new System.Windows.Forms.Label();
			this.lstAudio = new System.Windows.Forms.ListBox();
			((System.ComponentModel.ISupportInitialize)(this.trackVideo)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.stbStatus)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.stbFrame)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.stbTime)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.stbTimeLen)).BeginInit();
			this.grpShow.SuspendLayout();
			this.SuspendLayout();
			// 
			// videoPanel
			// 
			this.videoPanel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.videoPanel.Location = new System.Drawing.Point(0, 0);
			this.videoPanel.Name = "videoPanel";
			this.videoPanel.Size = new System.Drawing.Size(640, 480);
			this.videoPanel.TabIndex = 21;
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Red;
			// 
			// trackVideo
			// 
			this.trackVideo.AutoSize = false;
			this.trackVideo.Cursor = System.Windows.Forms.Cursors.Default;
			this.trackVideo.LargeChange = 30;
			this.trackVideo.Location = new System.Drawing.Point(0, 480);
			this.trackVideo.Maximum = 100;
			this.trackVideo.Name = "trackVideo";
			this.trackVideo.Size = new System.Drawing.Size(648, 20);
			this.trackVideo.TabIndex = 35;
			this.trackVideo.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackVideo.Scroll += new System.EventHandler(this.trackVideo_Scroll);
			// 
			// toolBarControl
			// 
			this.toolBarControl.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.toolBarControl.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBarControl.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							  this.tbtnPlay,
																							  this.tbtnPause,
																							  this.tbtnStop,
																							  this.tbtnDirectory,
																							  this.tbtnFS});
			this.toolBarControl.Divider = false;
			this.toolBarControl.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBarControl.DropDownArrows = true;
			this.toolBarControl.ImageList = this.imageList1;
			this.toolBarControl.Location = new System.Drawing.Point(648, 56);
			this.toolBarControl.Name = "toolBarControl";
			this.toolBarControl.ShowToolTips = true;
			this.toolBarControl.Size = new System.Drawing.Size(232, 26);
			this.toolBarControl.TabIndex = 36;
			this.toolBarControl.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right;
			this.toolBarControl.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBarControl_ButtonClick);
			// 
			// tbtnPlay
			// 
			this.tbtnPlay.Enabled = false;
			this.tbtnPlay.ImageIndex = 0;
			// 
			// tbtnPause
			// 
			this.tbtnPause.Enabled = false;
			this.tbtnPause.ImageIndex = 1;
			// 
			// tbtnStop
			// 
			this.tbtnStop.Enabled = false;
			this.tbtnStop.ImageIndex = 2;
			// 
			// tbtnDirectory
			// 
			this.tbtnDirectory.Text = "...";
			this.tbtnDirectory.Visible = false;
			// 
			// tbtnFS
			// 
			this.tbtnFS.Text = "Frame Step";
			// 
			// stbVideo
			// 
			this.stbVideo.Dock = System.Windows.Forms.DockStyle.None;
			this.stbVideo.Location = new System.Drawing.Point(0, 504);
			this.stbVideo.Name = "stbVideo";
			this.stbVideo.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						this.stbStatus,
																						this.stbFrame,
																						this.stbTime,
																						this.stbTimeLen});
			this.stbVideo.ShowPanels = true;
			this.stbVideo.Size = new System.Drawing.Size(640, 19);
			this.stbVideo.SizingGrip = false;
			this.stbVideo.TabIndex = 37;
			// 
			// stbStatus
			// 
			this.stbStatus.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.stbStatus.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.None;
			this.stbStatus.Text = "None";
			this.stbStatus.Width = 466;
			// 
			// stbFrame
			// 
			this.stbFrame.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.stbFrame.Text = "Frame";
			this.stbFrame.Width = 58;
			// 
			// stbTime
			// 
			this.stbTime.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.stbTime.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.stbTime.Text = "00:00:00";
			this.stbTime.Width = 58;
			// 
			// stbTimeLen
			// 
			this.stbTimeLen.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.stbTimeLen.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.stbTimeLen.Text = "00:00:00";
			this.stbTimeLen.Width = 58;
			// 
			// lblProperties
			// 
			this.lblProperties.Location = new System.Drawing.Point(648, 96);
			this.lblProperties.Name = "lblProperties";
			this.lblProperties.Size = new System.Drawing.Size(80, 16);
			this.lblProperties.TabIndex = 39;
			this.lblProperties.Text = "Eigenschaften:";
			// 
			// lstProperties
			// 
			this.lstProperties.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstProperties.Location = new System.Drawing.Point(728, 96);
			this.lstProperties.Name = "lstProperties";
			this.lstProperties.Size = new System.Drawing.Size(152, 69);
			this.lstProperties.TabIndex = 38;
			this.lstProperties.SelectedIndexChanged += new System.EventHandler(this.lstProperties_SelectedIndexChanged_1);
			// 
			// grpShow
			// 
			this.grpShow.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpShow.Controls.Add(this.ckbOnOff);
			this.grpShow.Location = new System.Drawing.Point(648, 0);
			this.grpShow.Name = "grpShow";
			this.grpShow.Size = new System.Drawing.Size(232, 48);
			this.grpShow.TabIndex = 40;
			this.grpShow.TabStop = false;
			this.grpShow.Text = "Anzeige";
			// 
			// ckbOnOff
			// 
			this.ckbOnOff.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbOnOff.Checked = true;
			this.ckbOnOff.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbOnOff.Location = new System.Drawing.Point(12, 20);
			this.ckbOnOff.Name = "ckbOnOff";
			this.ckbOnOff.Size = new System.Drawing.Size(204, 15);
			this.ckbOnOff.TabIndex = 3;
			this.ckbOnOff.Text = "ein/ausschalten";
			this.ckbOnOff.CheckedChanged += new System.EventHandler(this.ckbOnOff_CheckedChanged);
			// 
			// timerUpdateInfo
			// 
			this.timerUpdateInfo.Enabled = true;
			this.timerUpdateInfo.Interval = 30;
			this.timerUpdateInfo.Tick += new System.EventHandler(this.timerUpdateInfo_Tick);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(648, 176);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 42;
			this.label1.Text = "Audio Device:";
			this.label1.Visible = false;
			// 
			// lstAudio
			// 
			this.lstAudio.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstAudio.Location = new System.Drawing.Point(728, 176);
			this.lstAudio.Name = "lstAudio";
			this.lstAudio.Size = new System.Drawing.Size(152, 69);
			this.lstAudio.TabIndex = 41;
			this.lstAudio.Visible = false;
			this.lstAudio.SelectedIndexChanged += new System.EventHandler(this.lstAudio_SelectedIndexChanged);
			// 
			// uscVideoFile
			// 
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lstAudio);
			this.Controls.Add(this.grpShow);
			this.Controls.Add(this.lblProperties);
			this.Controls.Add(this.lstProperties);
			this.Controls.Add(this.stbVideo);
			this.Controls.Add(this.toolBarControl);
			this.Controls.Add(this.trackVideo);
			this.Controls.Add(this.videoPanel);
			this.Name = "uscVideoFile";
			this.Size = new System.Drawing.Size(888, 528);
			((System.ComponentModel.ISupportInitialize)(this.trackVideo)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.stbStatus)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.stbFrame)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.stbTime)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.stbTimeLen)).EndInit();
			this.grpShow.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		
		/// <summary> override window fn to handle graph events. </summary>
		protected override void WndProc( ref Message m )
		{
			if( m.Msg == WM_GRAPHNOTIFY )
			{
				_filterGraphControllerSource.OnGraphNotify();
				return;
			}
			base.WndProc( ref m );
		}

		public void Initalize(FilterGraphControllerSource filterGraphControllerSource, Filters filters)
		{
			PropertyPage p;
			Filter f;
			Filter audioDevice = null;
			_filters = filters;
			
			_filterGraphControllerSource = filterGraphControllerSource;
			_filterGraphControllerSource.USC = this;
			try
			{
				//_filterGraphControllerSource.Stop();
				if ( _filterGraphControllerSource.PreviewWindow == null )
					_filterGraphControllerSource.PreviewWindow = this.videoPanel;
			}
			catch (Exception ex)
			{ 
				Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}

			// Load property pages
			try
			{
				lstProperties.Items.Clear();
				for ( int c = 0; c < _filterGraphControllerSource.PropertyPages.Count; c++ )
				{
					p = _filterGraphControllerSource.PropertyPages[c];
					lstProperties.Items.Add(p.Name + "...");
				}
			}
			catch { }


			// Load audio devices
			
			lstAudio.Items.Clear();
			
			lstAudio.Items.Add( "(None)" );
			lstAudio.SelectedItem = ( audioDevice == null );

			for ( int c = 0; c < filters.AudioInputDevices.Count; c++ )
			{
				f = _filters.AudioInputDevices[c];
				lstAudio.Items.Add(f.Name);
				lstAudio.SelectedItem = ( audioDevice == f);
			}
			lstAudio.Enabled = (filters.AudioInputDevices .Count > 0);
	
			_filterGraphControllerSource.ClipStop();
			this.tbtnPlay.Enabled = true;
			this.trackVideo.Maximum = (int)_filterGraphControllerSource.ClipLength();

			//_filterGraphControllerSource.ClipPlay();
		}



		private void lstProperties_SelectedIndexChanged_1(object sender, System.EventArgs e)
		{
			try
			{
				ListBox m = sender as ListBox;
				_filterGraphControllerSource.PropertyPages[m.SelectedIndex].Show( this );
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Unable display property page. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		

		}
		private void lstAudio_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
			try
			{
				Filter audioDevice = null;

				// Get new audio device
				ListBox m = sender as ListBox;
				audioDevice = ( m.SelectedIndex>0 ? _filters.AudioInputDevices[m.SelectedIndex-1] : null );

				// Create capture object
				if ( ( audioDevice != null ) )
				{
					_filterGraphControllerSource = new FilterGraphControllerSource(_filterGraphControllerSource.SourceFile, audioDevice );
				}

			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Audio device not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}




		private void toolBarControl_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch(toolBarControl.Buttons.IndexOf(e.Button))
			{
			
				case 0: 

					_filterGraphControllerSource.ClipPlay();
//					this.tbtnPause.Enabled = true;
//					this.tbtnStop.Enabled = true;
					break;
				case 1: _filterGraphControllerSource.ClipPause();
//					this.tbtnPause.Enabled = false;
					break; 

				case 2:	_filterGraphControllerSource.ClipStop();
//						this.tbtnPause.Enabled = false;
//						this.tbtnStop.Enabled = false;
					break;	
				case 3: 
					string sourceFile = null;
					OpenFileDialog af = new OpenFileDialog();
					af.Title = "Open Media File...";
					af.Filter = clipFileFilters;
					if( af.ShowDialog() != DialogResult.OK )
						return;

					sourceFile = af.FileName;		
					break;
				case 4:
					_filterGraphControllerSource.StepFrames(1);
					break;

				
			}
			_filterGraphControllerSource.UpdateStatusBar(this.stbStatus,this.stbTime,this.stbTimeLen,this.stbFrame);
			_filterGraphControllerSource.UpdateTrackBar(this.trackVideo);
			_filterGraphControllerSource.UpdateToolBar(this.tbtnPlay,this.tbtnPause,this.tbtnStop);
		}

		private void ckbOnOff_CheckedChanged(object sender, System.EventArgs e)
		{
			OnOff = this.ckbOnOff.Checked;
		}

		private void trackVideo_Scroll(object sender, System.EventArgs e)
		{
			_filterGraphControllerSource.SetTrackBar(this.trackVideo.Value);
		}

		private void timerUpdateInfo_Tick(object sender, System.EventArgs e)
		{
			_filterGraphControllerSource.UpdateInfo(this.stbStatus,this.stbFrame,this.stbTime,this.stbTimeLen,this.trackVideo);
		}

		


		public Control PreviewWindow
		{
			get
			{
				return this.videoPanel;
			}
		}


		public bool OnOff
		{

			set
			{
				_OnOff = value;
				if(_OnOff)
				{
					try
					{
						if ( _filterGraphControllerSource.PreviewWindow == null )
							_filterGraphControllerSource.PreviewWindow = this.videoPanel ;
					}
					catch (Exception ex)
					{ 
						Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
					}

				}
				else
				{
					try
					{
						_filterGraphControllerSource.PreviewWindow = null;
					}
					catch (Exception ex)
					{ 
						Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
					}
				}

			}

		}


	}
}
