using System;
using MT.DataStructures;
using MT.MathBase;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr ICamera.
	/// </summary>
	public interface ICamera
	{
		string Name
		{	get;
		}

		string ConID
		{	get; 
		}

		FeaturePointData FPData
		{	get; 
		}

		/// <summary>
		/// Gets the current FrameID
		/// </summary>
		int CurFrameID
		{	
			get;	
			set;
		}

		vector3f Position
		{	get;
		}

		vector3f image_coord_to_world_coord(vector2f image_coord);
		vector3f image_coord_to_world_coord(double u, double v);
		vector2f world_coord_to_image_coord(vector3f world_coord);
		vector2f world_coord_to_image_coord(double xw, double yw, double zw);
					
	}
}


