using System;
using OpenGL;
using MT.DataStructures;
using System.Windows.Forms;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr cls3DView.
	/// </summary>
	public class cls3DView
	{
		//OpenGL
		public static uint				m_uint_HWND = 0;
		public static uint				m_uint_DC   = 0;
		public static uint				m_uint_RC   = 0;
		public static uint				m_uint_AttemptedInitialization = 0;

		//OpenGL Functions
		private bool	_OpenGLInitialized = false;
		private uint	_OpenGLWindowHWND;
		private uint	_OpenGLDC;
		private uint	_OpenGLRC;

//		private int			_maxGLFrame= -1;		//Stores Maximal viewable Tracked frame
		private int			_curGLFrame = -1;		//Stores Number of the currently showed frame in OpenGL Panel

		//Mousemove Variables
		private float					_dx;
		private float					_dy;
		private float					_rotx,_roty;				//!< rotation angles
//		private int						_startx,_starty;			//!< x,y mouse positions
		private float					_zoom;

		private int						_width;
		private int						_height;


		private bool					_redrawing = false;

//		private Control					_pnlOpenGL;
		private	TUKMain					_TUKMain;


		public bool Redrawing
		{
			get { return _redrawing ; }
		}
		public int curGLFrame
		{
			get { return _curGLFrame; }
			set { _curGLFrame = value; }
		}

		public float DX
		{
			get { return _dx; }
			set { _dx = value; }
		}

		public float DY
		{
			get { return _dy; }
			set { _dy = value; }
		}

		public void InitRotation()
		{
			_rotx = 0;
			_roty = 0;
			_zoom = 0;
		}

		public void AddRotation()
		{
			_rotx += _dx;							// increment rotation with
			_dx=0;									// delta angles
			_roty += _dy;  
			_dy=0;

		}

		public cls3DView(TUKMain tukMain)
		{
			_TUKMain = tukMain;
//			_pnlOpenGL = OpenGLPanel;
		}

		public void Initialize(int width, int height)
		{
			_width = width;
			_height = height;
		}

//			if (!_OpenGLInitialized)
//			{
//				_OpenGLInitialized = true;
//				_OpenGLWindowHWND = (uint)((_pnlOpenGL.Handle).ToInt32());
//				WGL.InitOpenGL(_OpenGLWindowHWND, ref _OpenGLDC, ref _OpenGLRC );
//			}
//			if (0 != _OpenGLRC)
//			{
//				this.OpenGLDraw( _pnlOpenGL.Size.Width, _pnlOpenGL.Size.Height,  _OpenGLDC,0,0,0,0,0,_curGLFrame);
//			}




		public TUKMain TUKMain
		{
			set
			{
				_TUKMain = value;
			}
		}

		//***************************************************************
		//***************************************************************
		//						OpenGL Windwow
		//***************************************************************
		//***************************************************************
		public void OpenGLDraw
			(
			int      int_WindowWidth,
			int      int_WindowHeight,
			uint     uint_DC,
			float    _dx, float _dy ,float _rotx ,float _roty,float _zoom,
			int		 FrameID
			)
		{
			int int_Phase = (int)(System.Environment.TickCount % 120000);
			float float_Phase = (float)(0.3f * (int_Phase));

			if (int_WindowWidth  <= 0)  int_WindowWidth  = 1;
			if (int_WindowHeight <= 0)  int_WindowHeight = 1;
			float[] lightpos = {0,0,3.0f,0};							// Light 0 position at 1,1,1
	
			GL.glViewport( 0, 0, int_WindowWidth, int_WindowHeight );

			GL.glEnable     ( GL.GL_DEPTH_TEST );						// Enable depth test
			GL.glDepthFunc  ( GL.GL_LEQUAL     );
			//GL.glEnable     ( GL.GL_CULL_FACE  );						// enable face culling
			//GL.glCullFace   ( GL.GL_FRONT_AND_BACK  );
			GL.glClearColor ( 1.0f, 1.0f, 1.0f, 0.0f );
			GL.glClear      ( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
			GL.glMatrixMode ( GL.GL_PROJECTION );
			GL.glLightModelfv(GL.GL_LIGHT_MODEL_TWO_SIDE, new float[]{1.0f, 1.0f, 1.0f, 1.0f});
			//GL.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, new float[]{1.0f, 1.0f, 1.0f, 1.0f});

			GL.glEnable		( GL.GL_LIGHTING);							// Turn on lighting
			GL.glEnable		( GL.GL_COLOR_MATERIAL);					// Let the material follow color
			GL.glLightfv	( GL.GL_LIGHT0,GL.GL_MODELVIEW, lightpos);	// set the light position
			//GL.glDisable(GL.GL_CULL_FACE);							// enable face culling
			GL.glEnable		( GL.GL_LIGHT0);							// Turn on the light 0
			GL.glShadeModel	( GL.GL_SMOOTH );							// Smooth shading
			//GL.glClearColor(1,1,1,1);									// set background color
			GL.glPolygonMode( GL.GL_FRONT, GL.GL_FILL);					// polygons are filled

			GL.glLoadIdentity();

			//GL.glOrtho( 0.0f, (float)(int_WindowWidth), 0.0f, (float)(int_WindowHeight), -1.0f, 1.0f );
			GLU.gluPerspective
				( 
				80.0,    // Field of view angle (Y angle; degrees)
				((double)(int_WindowWidth) / (double)(int_WindowHeight)), 
				1.0,     // Near plane
				20.0   // Far  plane
				);

			GL.glMatrixMode ( GL.GL_MODELVIEW );
			GL.glLoadIdentity();

			// Translating the camera to +600.0f Z is essentially
			// adding -600.0f to all drawing commands.  
			//GL.glTranslatef(  -4.2f,-1.8f, -5f );

//			GLU.gluLookAt( -4.0,  2.0,  1.0,
//				3.6,  1.8,  1.0+_zoom/200,
//				0.0, 0.0,  4.0);

			GLU.gluLookAt( -4.0, 0.6, 1.0,
							0.6, 0.6, 1.0+_zoom/800,
							0.0, 0.0, 4.0);

			//	GL.glRotatef( (0.11f * float_Phase), 1.0f, 0.0f, 0.0f );
			//	GL.glRotatef( (0.31f * float_Phase), 0.0f, 1.0f, 0.0f );
			//	GL.glRotatef( (0.19f * float_Phase), 0.0f, 0.0f, 1.0f );
		
//			Console.WriteLine("zoom: {0}",_zoom);
//			Console.WriteLine("roty: {0}",_roty);
//			Console.WriteLine("dy  : {0}",_dy);
			GL.glTranslatef( 0.0f, 0.0f, _zoom/960 );
			GL.glTranslatef((_roty+_dy)/20,0.0f,0.0f);
		
			GL.glTranslatef( 0.6f, 0.6f, 1.5f );
			GL.glRotatef(-(_rotx+_dx),0,0,1);               // z-rotation
			//GL.glRotatef(_roty+_dy,0,0,0);               // view-rotation
			GL.glTranslatef( -0.6f, -0.6f, -1.5f );

//			WGL.drawCylinder(0.3f, new vector3f(1,1,0),new vector3f(0,0,5),16, new vector3f(0,1,0));
//			WGL.drawCylinder(0.5f, new vector3f(0,1,0),new vector3f(0,0,5),16, new vector3f(1,0,0));
//			WGL.drawCylinder(0.1f, new vector3f(1,0,0),new vector3f(0,0,5),16, new vector3f(1,1,1));
//					
//			WGL.drawCylinder(0.2f, new vector3f(0,-1,0),new vector3f(1,0,5),16, new vector3f(0,0,1));

		
			if( _TUKMain != null)
			   _TUKMain.PaintFrame(FrameID,true);
			//			if(vtrackerdata!=null)
//				vtrackerdata.paintFrame(FrameID);



//			WGL.drawSphere(1,64,64);
//			GL.glTranslatef( 3.0f, 0.0f, 0.0f );
//			GL.glTranslatef( -6.0f, 0.0f, 0.0f );
//			GL.glTranslatef( 3.0f, 3.0f, 0.0f );
//			WGL.drawSphere(1,64,64);
//			GL.glTranslatef( 0.0f, -6.0f, 0.0f );
//			WGL.drawSphere(1,64,64);
			WGL.wglSwapBuffers( uint_DC );
			
			
		}

//		public void refreshGL()
//		{
//			OnReDraw();
////			this.OpenGLDraw( _pnlOpenGL.Size.Width, _pnlOpenGL.Size.Height,  _OpenGLDC,_dx,_dy,_rotx,_roty,_zoom,_curGLFrame);
//		}



//		public void pnlOpenGL_MouseMove(System.Windows.Forms.MouseEventArgs  e)
//		{	
//			int mouseX = e.X;
//			int mouseY = e.Y;
//
//			if (_mouseLeftDown)
//			{
//				_dx = (e.X - _startx)*_rotSensibility; // calculate delta angle
//				_dy = (e.Y - _starty)*_rotSensibility;
//			
//				//If mouse moved and not initialised, do init
//				//else draw new window according to the changes
//				OnReDraw();
////				if (!_OpenGLInitialized)
////				{
////					_OpenGLInitialized = true;
////					_OpenGLWindowHWND = (uint)((_pnlOpenGL.Handle).ToInt32());
////					WGL.InitOpenGL( _OpenGLWindowHWND, ref _OpenGLDC, ref _OpenGLRC );
////				}
////				if (0 != _OpenGLRC)
////				{
////					this.OpenGLDraw( _pnlOpenGL.Size.Width, _pnlOpenGL.Size.Height,  _OpenGLDC,_dx,_dy,_rotx,_roty,_zoom,_curGLFrame);
////				}
//			}
//		}

//		public void pnlOpenGL_MouseDown(System.Windows.Forms.MouseEventArgs  e)
//		{
//			switch (e.Button) 
//			{
//				case MouseButtons.Left:
//					
//					_mouseLeftDown = true;
//					_startx = e.X;                      // keep start position
//					_starty = e.Y;
//					break;
//
//				case MouseButtons.Right:
//					
//					_rotx = 0;
//					_roty = 0;
//					_zoom = 0;
//					refreshGL();
//					break;
//			}
//
//		}

//		public void pnlOpenGL_MouseUp(System.Windows.Forms.MouseEventArgs  e)
//		{
//			switch (e.Button) 
//			{
//				case MouseButtons.Left:
//					
//					_mouseLeftDown = false;
//					_rotx += _dx;							// increment rotation with
//					_dx=0;									// delta angles
//					_roty += _dy;  
//					_dy=0;
//					
//					break;
//			}
//
//		}

//		delegate void OnReDrawDelegate();

		public void OnReDraw()
		{
				if (0 != _OpenGLRC)
				{
					_redrawing = true;
					this.OpenGLDraw(_width, _height,  _OpenGLDC,_dx, _dy, _rotx, _roty,_zoom,_curGLFrame);
					_redrawing = false;
				}
		}

		public void InitializeOpenGL(uint Handle)
		{
			_OpenGLInitialized = true;
			_OpenGLWindowHWND = Handle;
			WGL.InitOpenGL( _OpenGLWindowHWND, ref _OpenGLDC, ref _OpenGLRC );

		}

		public bool OpenGLInitialized
		{
			get { return _OpenGLInitialized; }
		}


		public float Zoom 
		{
			get { return _zoom; }
			set { _zoom = value; }
		}
		


	}
}
