using System;
using System.Collections;
using MT.DataStructures;
using tsai;
using MT.Network;
using MT.Synchronization;
using OpenGL;
using MT.MathBase;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsCamera.
	/// </summary>
	public class clsCamera: clsClient, ICamera, IPaintable
	{
		protected int				_curFrameID =-1;

		private vector3f	_color;

		//ToDo: use
		protected bool				_Calibrated;
		protected bool				_Running;


		
		public clsCamera(clsNetClient NetClient, MT.Network.clsBroadcastServer Server, WorkerThread wt):base(NetClient,Server,wt)
		{
			_color = new vector3f();

			switch(Name)
			{
				case "MT1":
					_color.X = 0;
					_color.Y = 0;
					_color.Z = 1;
					break;
				case "MT2":
					_color.X = 0;
					_color.Y = 1;
					_color.Z = 0;
					break;
				case "MT3":
					_color.X = 0;
					_color.Y = 1;
					_color.Z = 1;
					break;
				case "MT4":
					_color.X = 1;
					_color.Y = 0;
					_color.Z = 0;
					break;
				case "MT5":
					_color.X = 1;
					_color.Y = 0;
					_color.Z = 1;
					break;
				case "MT6":
					_color.X = 1;
					_color.Y = 1;
					_color.Z = 0;
					break;
				default:
					_color.X = 0;
					_color.Y = 0;
					_color.Z = 0;
					break;
			}
		}

		/// <summary>
		/// Gets Name
		/// </summary>
		public string Name
		{	get { return base.Host; }	 }

		/// <summary>
		/// Gets the Connection ID
		/// </summary>
		public string ConID
		{	get { return base.ConnectionID; }	 }
		
		/// <summary>
		/// Gets the FPData
		/// </summary>
//		public FeaturePointData FPData
//		{	get { return base.FPData; }	 }

		/// <summary>
		/// Gets the current FrameID
		/// </summary>
		public int CurFrameID
		{	
			get 
			{ return _curFrameID; }	
			set 
			{
				_curFrameID = value;
			}
		}

		public vector3f Position
		{
			get {	
				double x=0;
				double y=0;
				double z=0;
				if (base.Tsai != null)
					base.Tsai.get_camera_position(ref x,ref y,ref z);
			
				return new vector3f((float)x,(float)y,(float)z);
			}
		}

		public vector3f image_coord_to_world_coord(vector2f image_coords)
		{
			return image_coord_to_world_coord(image_coords.X, image_coords.Y);
		}
		public vector3f image_coord_to_world_coord(double u, double v)
		{
			double x=0;
			double y=0;
			double z=0;

			base.Tsai.image_coord_to_world_coord(u,v,ref x,ref y,ref z);

			return new vector3f((float)x,(float)y,(float)z);
		}

		public vector2f world_coord_to_image_coord(vector3f world_coords)
		{
			return world_coord_to_image_coord(world_coords.X, world_coords.Y, world_coords.Z);
		}
		public vector2f world_coord_to_image_coord(double x,double y,double z)
		{
			double u=0;
			double v=0;

			base.Tsai.world_coord_to_image_coord(x,y,z, ref u, ref v);

			return new vector2f((float)u,(float)v);
		}

		#region IPaintable Member

		public void Paint()
		{

			//Nur  zeichnen, wenn Tsai empfange
			if (base.Tsai !=null)
			{
				//Logitech Webcam
			
				double xc = new double();
				double yc = new double();
				double zc = new double();
				double xw = new double();
				double yw = new double();
				double zw = new double();

			

				// Sichtpyramide
			
				vector3f campos = this.Position/1000;


				GL.glColor3f(_color.X ,_color.Y ,_color.Z);

				//			base.image_coord_to_world_coord(0, 0, 0.01f, ref xw, ref yw);
				//			vector3f dir1 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
				//					
				//			base.image_coord_to_world_coord(639, 0, 0.01f, ref xw, ref yw);
				//			vector3f dir2 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
				//
				//			base.image_coord_to_world_coord(0, 479, 0.01f, ref xw, ref yw);
				//			vector3f dir3 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
				//
				//			base.image_coord_to_world_coord(639, 479, 0.01f, ref xw, ref yw);
				//			vector3f dir4 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
				//
				//			base.image_coord_to_world_coord(320, 479, 0.01f, ref xw, ref yw);
				//			vector3f dir5 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
				//		
					
				//			WGL.drawLine(campos, dir1);
				//			WGL.drawLine(campos, dir2);
				//			WGL.drawLine(campos, dir3);
				//			WGL.drawLine(campos, dir4);
				//
				//			WGL.drawLine(dir1, dir2);
				//			WGL.drawLine(dir2, dir4);
				//			WGL.drawLine(dir3, dir1);
				//			WGL.drawLine(dir4, dir5);
				//			WGL.drawLine(dir5, dir3);


				vector3f vec_a = new vector3f();
				vector3f vec_b = new vector3f();
				for (int i=0; i<620; i+=20)
				{
					base.Tsai.image_coord_to_world_coord(i, 479, ref xw, ref yw, 0.01f);
				
					vec_a.X = (float)xw/1000;
					vec_a.Y = (float)yw/1000;
					vec_a.Z = 0.01f;
				
					base.Tsai.image_coord_to_world_coord(i+20, 479, ref xw, ref yw, 0.01f);
					vec_b.X = (float)xw/1000;
					vec_b.Y = (float)yw/1000;
					vec_b.Z = 0.01f;
					WGL.drawLine(vec_a, vec_b);
				}
		
				// Webcam
				GL.glColor3f(0,0,0);

				GL.glTranslatef(campos.X, campos.Y, campos.Z);
				GL.glRotatef((float)(-base.Tsai._cc.Rx/Math.PI*180),1,0,0);
				GL.glRotatef((float)(-base.Tsai._cc.Ry/Math.PI*180),0,1,0);
				GL.glRotatef((float)(-base.Tsai._cc.Rz/Math.PI*180),0,0,1);

				GL.glRotatef(90,0,0,1);
				//WGL.drawSphere(0.1f, 16, 16, new vector3f(0.4f,0.4f,0.4f));
				//Kameragehuse
				WGL.drawSphere(0.1f, 16, 16, new vector3f(_color.X ,_color.Y ,_color.Z));
				//Kamerasockel
				WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.15f,0,0),36,new vector3f(0,0,0));
				WGL.fillCircleYZ(new vector3f(0.15f,0,0),0.1f,36);
				GL.glRotatef(-90,0,0,1);
				GL.glRotatef(-90,0,1,0);
				//Objektiv
				WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.12f,0,0),36,new vector3f(0,0,0));
				WGL.fillCircleYZ(new vector3f(0.12f,0,0),0.03f,36);
				GL.glRotatef(90,0,1,0);

				GL.glRotatef((float)(base.Tsai._cc.Rz/Math.PI*180),0,0,1);
				GL.glRotatef((float)(base.Tsai._cc.Ry/Math.PI*180),0,1,0);
				GL.glRotatef((float)(base.Tsai._cc.Rx/Math.PI*180),1,0,0);					
				GL.glTranslatef(-campos.X, -campos.Y, -campos.Z);
			}
		}

		#endregion
	}
}
