using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MT.DataStructures;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr frm3DView.
	/// </summary>
	public class frm3DView : System.Windows.Forms.Form
	{
		private	cls3DView				_3DView;
		
//		int			_maxGLFrame= -1;		//Stores Maximal viewable Tracked frame
		int			_curGLFrame = -1;		//Stores Number of the currently showed frame in OpenGL Panel
		
		private bool					_mouseLeftDown = false;
		private float					_rotSensibility = 1.0f;     //!< mouse rotation sensibility
		private int						_startx,_starty;			//!< x,y mouse positions

		private	clsBPData				_BPData;
		private clsServerController		_Controller;

		private bool	_activated = true;

		private System.Windows.Forms.TrackBar tbrFrame;
		private System.Windows.Forms.Panel pnlOpenGL;
		private System.Windows.Forms.Timer timerOpenGL;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.TextBox txtInfo;
		private System.Windows.Forms.Button btnSave;
		private System.ComponentModel.IContainer components;
		delegate void OnReDrawDelegate();


		public frm3DView()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.tbrFrame = new System.Windows.Forms.TrackBar();
			this.pnlOpenGL = new System.Windows.Forms.Panel();
			this.timerOpenGL = new System.Windows.Forms.Timer(this.components);
			this.lblInfo = new System.Windows.Forms.Label();
			this.txtInfo = new System.Windows.Forms.TextBox();
			this.btnSave = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).BeginInit();
			this.SuspendLayout();
			// 
			// tbrFrame
			// 
			this.tbrFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbrFrame.AutoSize = false;
			this.tbrFrame.Location = new System.Drawing.Point(0, 616);
			this.tbrFrame.Maximum = 0;
			this.tbrFrame.Name = "tbrFrame";
			this.tbrFrame.Size = new System.Drawing.Size(976, 20);
			this.tbrFrame.TabIndex = 35;
			this.tbrFrame.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbrFrame.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			this.tbrFrame.GotFocus += new System.EventHandler(this.Ctrl_GotFocus);
			this.tbrFrame.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.tbrFrame.Scroll += new System.EventHandler(this.tbrFrame_Scroll);
			// 
			// pnlOpenGL
			// 
			this.pnlOpenGL.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlOpenGL.BackColor = System.Drawing.Color.Black;
			this.pnlOpenGL.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlOpenGL.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pnlOpenGL.Location = new System.Drawing.Point(0, 0);
			this.pnlOpenGL.Name = "pnlOpenGL";
			this.pnlOpenGL.Size = new System.Drawing.Size(736, 616);
			this.pnlOpenGL.TabIndex = 34;
			this.pnlOpenGL.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			this.pnlOpenGL.Resize += new System.EventHandler(this.pnlOpenGL_Resize);
			this.pnlOpenGL.GotFocus += new System.EventHandler(this.Ctrl_GotFocus);
			this.pnlOpenGL.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseUp);
			this.pnlOpenGL.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlOpenGL_Paint);
			this.pnlOpenGL.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseMove);
			this.pnlOpenGL.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.pnlOpenGL.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseDown);
			// 
			// timerOpenGL
			// 
			this.timerOpenGL.Tick += new System.EventHandler(this.timerOpenGL_Tick_1);
			// 
			// lblInfo
			// 
			this.lblInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblInfo.BackColor = System.Drawing.Color.WhiteSmoke;
			this.lblInfo.Location = new System.Drawing.Point(736, 0);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(240, 616);
			this.lblInfo.TabIndex = 36;
			// 
			// txtInfo
			// 
			this.txtInfo.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtInfo.Location = new System.Drawing.Point(800, 480);
			this.txtInfo.Multiline = true;
			this.txtInfo.Name = "txtInfo";
			this.txtInfo.Size = new System.Drawing.Size(184, 136);
			this.txtInfo.TabIndex = 37;
			this.txtInfo.Text = "Information";
			// 
			// btnSave
			// 
			this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSave.Location = new System.Drawing.Point(760, 440);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(168, 24);
			this.btnSave.TabIndex = 38;
			this.btnSave.Text = "Speichern";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// frm3DView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(976, 637);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.lblInfo);
			this.Controls.Add(this.pnlOpenGL);
			this.Controls.Add(this.tbrFrame);
			this.Controls.Add(this.txtInfo);
			this.Name = "frm3DView";
			this.Text = "frm3DView";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frm3DView_Closing);
			this.GotFocus += new System.EventHandler(this.frm3DView_GotFocus);
			this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			this.LostFocus += new System.EventHandler(this.Ctrl_LostFocus);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public void Initialize(clsServerController Controller)
		{
			_Controller = Controller;

			_3DView = _Controller.DView;

			_BPData = _Controller.BPData;

			_Controller.tukMain.NewTrack +=new MTServer.TUKMain.NewTrackDelegate(_TUKMain_NewTrack);
			_Controller.ClientCollection.NewClient +=new MTServer.clsCameras.NewClientConnectDelegate(ClientCollection_NewClient);
			_Controller.tukMain.TrackerInformation +=new MTServer.TrackerInformationDelegate(TUK_TrackerInformation);
			_3DView.Initialize(this.pnlOpenGL.Width, this.pnlOpenGL.Height);

			//timerOpenGL.Enabled = true;
		}

		private void tbrFrame_Scroll(object sender, System.EventArgs e)
		{
			_curGLFrame = tbrFrame.Value;
//			refreshGL();
			OnReDraw();

		}

//		private void refreshGL()
//		{
//			_3DView.refreshGL();
//		}

		private void pnlOpenGL_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			OnReDraw();
//			refreshGL();
		}

		private void pnlOpenGL_MouseMove(object sender, System.Windows.Forms.MouseEventArgs  e)
		{	
//			int mouseX = e.X;
//			int mouseY = e.Y;

			if (_mouseLeftDown)
			{
				_3DView.DX = (e.X - _startx)*_rotSensibility; // calculate delta angle
				_3DView.DY = (e.Y - _starty)*_rotSensibility;
			
				OnReDraw();

			}
//			_3DView.pnlOpenGL_MouseMove(e);
		}

		private void pnlOpenGL_MouseDown(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			pnlOpenGL.Focus();

			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = true;
					_startx = e.X;                      // keep start position
					_starty = e.Y;
					break;

				case MouseButtons.Right:
					
					_3DView.InitRotation();
//					refreshGL();
					OnReDraw();
					break;
			}

		}

		private void pnlOpenGL_MouseUp(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = false;

					_3DView.AddRotation();
					
					break;
			}

//			_3DView.pnlOpenGL_MouseUp(e);
		}

		public void pnlOpenGL_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
//			_3DView.pnlOpenGL_MouseWheel(e);
			Console.WriteLine("Zoom: {0}", _3DView.Zoom);

			_3DView.Zoom += e.Delta;
		
			OnReDraw();

		}

		private void Ctrl_GotFocus(object sender, EventArgs e)
		{
			Console.WriteLine("{0} got focus", sender.ToString());
		}

		private void Ctrl_LostFocus(object sender, EventArgs e)
		{
			Console.WriteLine("{0} lost focus", sender.ToString());
		}

		private void timerOpenGL_Tick_1(object sender, System.EventArgs e)
		{
//			refreshGL();
			OnReDraw();

		}

		delegate void setTextDelegate(string value);

		private void setText(string value)
		{
			this.lblInfo.SuspendLayout();
			this.lblInfo.Text = value;
			this.lblInfo.ResumeLayout();
		}



		public string TextInformation
		{
//			get{return this.txtInfo.Text;}
//			set
//			{
//				this.txtInfo.Text = value;
//			}
			get{return this.lblInfo.Text;}
			set
			{
				if(InvokeRequired)
				{
					BeginInvoke(new setTextDelegate(setText),new Object[]{value});
				}
				else
				{
					setText(value);
				}
			}
		}

		private void frm3DView_Closing(object sender, CancelEventArgs e)
		{
			_activated = false;
		}

		private bool _redrawing = false;
        
		public void OnReDraw()
		{
			if(_activated && !_redrawing)
			{
				if (this.pnlOpenGL.InvokeRequired)
				{
					this.pnlOpenGL.BeginInvoke(new OnReDrawDelegate(OnReDraw),new object[]{});
				}
				else
				{
					if (!_3DView.OpenGLInitialized)
					{
						_3DView.InitializeOpenGL((uint)((this.pnlOpenGL.Handle).ToInt32()));
					}
				
					_redrawing = true;
					_3DView.OnReDraw();
					Application.DoEvents();
					_redrawing = false;

					

				}
			}

		}

		private delegate void TrackerInformationDelegate (object sender, TrackerEventArgs e);

		private void TUK_TrackerInformation(object sender, TrackerEventArgs e)
		{
			if (InvokeRequired)
			{
				BeginInvoke(new TrackerInformationDelegate(TUK_TrackerInformation),new object[]{sender, e});
			}
			else
			{
				this.lblInfo.Text = e.Info;
			}
		}


		private void _TUKMain_NewTrack(int FrameID)
		{
			_3DView.curGLFrame = FrameID;

			if(!_3DView.Redrawing)
				OnReDraw();
//			Application.DoEvents();
		}

		private void pnlOpenGL_Resize(object sender, EventArgs e)
		{
			_3DView.Initialize(pnlOpenGL.Width, pnlOpenGL.Height);
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			_Controller.StopSynchronizer();

			const string clipFileFilters =
			"MotionXTrack Files (mxt)|*.mxt|" +
			"All Files (*.*)|*.*";

			SaveFileDialog af = new SaveFileDialog();
			af.Title = "Save mxt File...";
			af.Filter = clipFileFilters;
			if( af.ShowDialog() != DialogResult.OK )
				return;
			
			_BPData.Save(af.FileName);
		}


		private void frm3DView_GotFocus(object sender, EventArgs e)
		{
//			refreshGL();
			OnReDraw();

			Console.WriteLine("3D got Focus");
		}

		private void ClientCollection_NewClient(string conID, clsClient client)
		{
			client.CalibratedClient +=new MTServer.clsClient.CalibratedClientDelegate(client_CalibratedClient);
		}

		private void client_CalibratedClient(string Message)
		{
			OnReDraw();
		}
	}
}
