using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using OpenGL;
using MT.DataStructures;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr usc3DView.
	/// </summary>
	public class usc3DView : System.Windows.Forms.UserControl
	{

		delegate void OnReDrawDelegate();
		private	cls3DView				_3DView;
		private bool	_activated = true;

		private bool					_mouseLeftDown = false;
		private float					_rotSensibility = 1.0f;     //!< mouse rotation sensibility
		private int						_startx,_starty;			//!< x,y mouse positions


		//OpenGL
		public static uint				m_uint_HWND = 0;
		public static uint				m_uint_DC   = 0;
		public static uint				m_uint_RC   = 0;
		public static uint				m_uint_AttemptedInitialization = 0;

		//OpenGL Functions
//		private bool	_OpenGLInitialized = false;
//		private uint	_OpenGLWindowHWND;
//		private uint	_OpenGLDC;
//		private uint	_OpenGLRC;

//		int			_maxGLFrame= -1;		//Stores Maximal viewable Tracked frame
		int			_curGLFrame = -1;		//Stores Number of the currently showed frame in OpenGL Panel

		private System.Windows.Forms.Panel pnlOpenGL;
		private System.Windows.Forms.TrackBar tbrFrame;
		private System.Windows.Forms.Timer timerOpenGL;
		private System.ComponentModel.IContainer components;

		public usc3DView()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

			_3DView.InitializeOpenGL((uint)((this.pnlOpenGL.Handle).ToInt32()));

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pnlOpenGL = new System.Windows.Forms.Panel();
			this.tbrFrame = new System.Windows.Forms.TrackBar();
			this.timerOpenGL = new System.Windows.Forms.Timer(this.components);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlOpenGL
			// 
			this.pnlOpenGL.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlOpenGL.BackColor = System.Drawing.Color.Black;
			this.pnlOpenGL.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlOpenGL.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pnlOpenGL.Location = new System.Drawing.Point(8, 6);
			this.pnlOpenGL.Name = "pnlOpenGL";
			this.pnlOpenGL.Size = new System.Drawing.Size(872, 586);
			this.pnlOpenGL.TabIndex = 31;
			this.pnlOpenGL.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseUp);
			this.pnlOpenGL.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlOpenGL_Paint);
			this.pnlOpenGL.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseMove);
			this.pnlOpenGL.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseDown);
			this.pnlOpenGL.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			// 
			// tbrFrame
			// 
			this.tbrFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbrFrame.AutoSize = false;
			this.tbrFrame.Location = new System.Drawing.Point(0, 592);
			this.tbrFrame.Maximum = 0;
			this.tbrFrame.Name = "tbrFrame";
			this.tbrFrame.Size = new System.Drawing.Size(888, 20);
			this.tbrFrame.TabIndex = 33;
			this.tbrFrame.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbrFrame.Scroll += new System.EventHandler(this.tbrFrame_Scroll);
			// 
			// timerOpenGL
			// 
			this.timerOpenGL.Tick += new System.EventHandler(this.timerOpenGL_Tick);
			// 
			// usc3DView
			// 
			this.Controls.Add(this.tbrFrame);
			this.Controls.Add(this.pnlOpenGL);
			this.Name = "usc3DView";
			this.Size = new System.Drawing.Size(944, 632);
			//this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	
		public void Initialize(cls3DView GLView, TUKMain tukMain)
		{
			_3DView = GLView;
			//_3DView = new cls3DView(this.pnlOpenGL, tukMain);
			_3DView.Initialize(this.pnlOpenGL.Width, this.pnlOpenGL.Height);
			

			timerOpenGL.Enabled = true;
		}

		private void timerOpenGL_Tick(object sender, System.EventArgs e)
		{
			OnReDraw();
		}

		private void tbrFrame_Scroll(object sender, System.EventArgs e)
		{
			_curGLFrame = tbrFrame.Value;
			OnReDraw();
		}

		private void refreshGL()
		{
//			_3DView.refreshGL();
		}

		private void pnlOpenGL_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			OnReDraw();
		}

		private void pnlOpenGL_MouseMove(object sender, System.Windows.Forms.MouseEventArgs  e)
		{	
			int mouseX = e.X;
			int mouseY = e.Y;

			if (_mouseLeftDown)
			{
				_3DView.DX = (e.X - _startx)*_rotSensibility; // calculate delta angle
				_3DView.DY = (e.Y - _starty)*_rotSensibility;
			
				OnReDraw();

			}
		}

		private void pnlOpenGL_MouseDown(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			pnlOpenGL.Focus();

			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = true;
					_startx = e.X;                      // keep start position
					_starty = e.Y;
					break;

				case MouseButtons.Right:
					
					_3DView.InitRotation();
					OnReDraw();
					break;
			}		
		}

		private void pnlOpenGL_MouseUp(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = false;

					_3DView.AddRotation();
					
					break;
			}		
		}

		public void pnlOpenGL_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			
			Console.WriteLine("Zoom: {0}", _3DView.Zoom);

			_3DView.Zoom += e.Delta;
		
			OnReDraw();
		}

		public void OnReDraw()
		{
			if(_activated)
			{
				if (this.pnlOpenGL.InvokeRequired)
				{
					this.pnlOpenGL.BeginInvoke(new OnReDrawDelegate(OnReDraw),new object[]{});
				}
				else
				{
					if (!_3DView.OpenGLInitialized)
					{
						_3DView.InitializeOpenGL((uint)((this.pnlOpenGL.Handle).ToInt32()));
					}
				
					_3DView.OnReDraw();

				}
			}

		}



		

	}
}
