using System;
using OpenGL;
using System.Windows.Forms;
using MT.MathBase;

namespace MT.DataStructures
{
	/// <summary>
	/// Zusammenfassung fr cls3DView.
	/// </summary>
	public class cls3DView
	{
		//OpenGL
		public static uint				m_uint_HWND = 0;
		public static uint				m_uint_DC   = 0;
		public static uint				m_uint_RC   = 0;
		public static uint				m_uint_AttemptedInitialization = 0;

		//OpenGL Functions
		private bool	_OpenGLInitialized = false;
		private uint	_OpenGLWindowHWND;
		private uint	_OpenGLDC;
		private uint	_OpenGLRC;

		private int			_curFrame = 0;		//Stores Number of the currently showed frame in OpenGL Panel

		//Mousemove Variables
		private float					_dx;
		private float					_dy;
		private float					_rotx,_roty;				//!< rotation angles
		private float					_zoom;

		private int						_width;						//Width of drawing Panel
		private int						_height;					//Height of drawing Panel
		
		private bool					_redrawing = false;			// Flag ist true while a Redraw is occuring

		private clsBPData				_BPData = new clsBPData();


		public bool Redrawing
		{
			get { return _redrawing ; }
		}
		public int curFrame
		{
			get { return _curFrame; }
			set { _curFrame = value; }
		}

		public float DX
		{
			get { return _dx; }
			set { _dx = value; }
		}

		public float DY
		{
			get { return _dy; }
			set { _dy = value; }
		}

		public void InitRotation()
		{
			_rotx = 0;
			_roty = 0;
			_zoom = 0;
		}

		public void AddRotation()
		{
			_rotx += _dx;							// increment rotation with
			_dx=0;									// delta angles
			_roty += _dy;  
			_dy=0;

		}

		public cls3DView()
		{
//			_pnlOpenGL = OpenGLPanel;
		}
		public cls3DView(clsBPData BPData)
		{
			_BPData = BPData;
		}

		public void Initialize(int width, int height)
		{
			_width = width;
			_height = height;
		}

//			if (!_OpenGLInitialized)
//			{
//				_OpenGLInitialized = true;
//				_OpenGLWindowHWND = (uint)((_pnlOpenGL.Handle).ToInt32());
//				WGL.InitOpenGL(_OpenGLWindowHWND, ref _OpenGLDC, ref _OpenGLRC );
//			}
//			if (0 != _OpenGLRC)
//			{
//				this.OpenGLDraw( _pnlOpenGL.Size.Width, _pnlOpenGL.Size.Height,  _OpenGLDC,0,0,0,0,0,_curFrame);
//			}


		//***************************************************************
		//***************************************************************
		//						OpenGL Windwow
		//***************************************************************
		//***************************************************************
		public void OpenGLDraw
			(
			int      int_WindowWidth,
			int      int_WindowHeight,
			uint     uint_DC,
			float    _dx, float _dy ,float _rotx ,float _roty,float _zoom,
			int		 FrameID
			)
		{
			int int_Phase = (int)(System.Environment.TickCount % 120000);
			float float_Phase = (float)(0.3f * (int_Phase));

			if (int_WindowWidth  <= 0)  int_WindowWidth  = 1;
			if (int_WindowHeight <= 0)  int_WindowHeight = 1;
			float[] lightpos = {0,0,3.0f,0};							// Light 0 position at 1,1,1
	
			GL.glViewport( 0, 0, int_WindowWidth, int_WindowHeight );

			GL.glEnable     ( GL.GL_DEPTH_TEST );						// Enable depth test
			GL.glDepthFunc  ( GL.GL_LEQUAL     );
			//GL.glEnable     ( GL.GL_CULL_FACE  );						// enable face culling
			//GL.glCullFace   ( GL.GL_FRONT_AND_BACK  );
			GL.glClearColor ( 1.0f, 1.0f, 1.0f, 0.0f );
			GL.glClear      ( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
			GL.glMatrixMode ( GL.GL_PROJECTION );
			GL.glLightModelfv(GL.GL_LIGHT_MODEL_TWO_SIDE, new float[]{1.0f, 1.0f, 1.0f, 1.0f});
			//GL.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT, new float[]{1.0f, 1.0f, 1.0f, 1.0f});

			GL.glEnable		( GL.GL_LIGHTING);							// Turn on lighting
			GL.glEnable		( GL.GL_COLOR_MATERIAL);					// Let the material follow color
			GL.glLightfv	( GL.GL_LIGHT0,GL.GL_MODELVIEW, lightpos);	// set the light position
			//GL.glDisable(GL.GL_CULL_FACE);							// enable face culling
			GL.glEnable		( GL.GL_LIGHT0);							// Turn on the light 0
			GL.glShadeModel	( GL.GL_SMOOTH );							// Smooth shading
			//GL.glClearColor(1,1,1,1);									// set background color
			GL.glPolygonMode( GL.GL_FRONT, GL.GL_FILL);					// polygons are filled

			GL.glLoadIdentity();

			//GL.glOrtho( 0.0f, (float)(int_WindowWidth), 0.0f, (float)(int_WindowHeight), -1.0f, 1.0f );
			GLU.gluPerspective
				( 
				80.0,    // Field of view angle (Y angle; degrees)
				((double)(int_WindowWidth) / (double)(int_WindowHeight)), 
				1.0,     // Near plane
				20.0   // Far  plane
				);

			GL.glMatrixMode ( GL.GL_MODELVIEW );
			GL.glLoadIdentity();

			// Translating the camera to +600.0f Z is essentially
			// adding -600.0f to all drawing commands.  
			//GL.glTranslatef(  -4.2f,-1.8f, -5f );


			GLU.gluLookAt( -4.0, 0.6, 1.0,
							0.6, 0.6, 1.0+_zoom/800,
							0.0, 0.0, 4.0);

			//	GL.glRotatef( (0.11f * float_Phase), 1.0f, 0.0f, 0.0f );
			//	GL.glRotatef( (0.31f * float_Phase), 0.0f, 1.0f, 0.0f );
			//	GL.glRotatef( (0.19f * float_Phase), 0.0f, 0.0f, 1.0f );
		
//			Console.WriteLine("zoom: {0}",_zoom);
//			Console.WriteLine("roty: {0}",_roty);
//			Console.WriteLine("dy  : {0}",_dy);
			GL.glTranslatef( 0.0f, 0.0f, _zoom/960 );
			GL.glTranslatef((_roty+_dy)/20,0.0f,0.0f);
		
			GL.glTranslatef( 0.6f, 0.6f, 1.5f );
			GL.glRotatef(-(_rotx+_dx),0,0,1);               // z-rotation
			//GL.glRotatef(_roty+_dy,0,0,0);               // view-rotation
			GL.glTranslatef( -0.6f, -0.6f, -1.5f );


			_BPData.Paint(_curFrame);

			// Weltkoordinaten Offset
			float dx = -2.4f;
			float dy = -1.2f;
			float dz =  0.0f;
			
			//Draw Floor
			GL.glColor3f(0.5f,0.5f,0.5f);
			for (int x=0; x<7; x++)
			{
				for (int y=0; y<4; y++)
				{
					WGL.drawRectangle(	new vector3f( (float)(x*1.2+1.18)+dx, (float)(y*1.2+1.18)+dy, 0.0f+dz),
						new vector3f( (float)(x*1.2+1.18)+dx, (float)(y*1.2+0.02)+dy, 0.0f+dz),
						new vector3f( (float)(x*1.2+0.02)+dx, (float)(y*1.2+1.18)+dy, 0.0f+dz),
						new vector3f( (float)(x*1.2+0.02)+dx, (float)(y*1.2+0.02)+dy, 0.0f+dz));
				}
			}
			WGL.drawRectangle(	new vector3f(10.2f+dx, -0.02f+dy, 0.0f+dz),
				new vector3f(10.2f+dx, -2.0f+dy,  0.0f+dz),
				new vector3f(-2.0f+dx, -0.02f+dy, 0.0f+dz),
				new vector3f(-2.0f+dx, -2.0f+dy,  0.0f+dz));

			WGL.drawRectangle(	new vector3f(10.2f+dx, 5.6f+dy,  0.0f+dz),
				new vector3f(10.2f+dx, 3.62f+dy, 0.0f+dz),
				new vector3f(-2.0f+dx, 5.6f+dy,  0.0f+dz),
				new vector3f(-2.0f+dx, 3.62f+dy, 0.0f+dz));

			WGL.drawRectangle(	new vector3f(10.2f+dx, 3.62f+dy,  0.0f+dz),
				new vector3f(10.2f+dx, -0.02f+dy, 0.0f+dz),
				new vector3f(7.22f+dx, 3.62f+dy,  0.0f+dz),
				new vector3f(7.22f+dx, -0.02f+dy, 0.0f+dz));

			WGL.drawRectangle(	new vector3f(-0.02f+dx, 3.62f+dy,  0.0f+dz),
				new vector3f(-0.02f+dx, -0.02f+dy, 0.0f+dz),
				new vector3f(-2.0f+dx,  3.62f+dy,  0.0f+dz),
				new vector3f(-2.0f+dx,  -0.02f+dy, 0.0f+dz));


			WGL.wglSwapBuffers( uint_DC );
			
			
		}

		public void refreshGL()
		{
			OnReDraw();
//			this.OpenGLDraw( _pnlOpenGL.Size.Width, _pnlOpenGL.Size.Height,  _OpenGLDC,_dx,_dy,_rotx,_roty,_zoom,_curFrame);
		}




		public void OnReDraw()
		{
				if (0 != _OpenGLRC)
				{
					_redrawing = true;
					this.OpenGLDraw(_width, _height,  _OpenGLDC,_dx, _dy, _rotx, _roty,_zoom,_curFrame);
					_redrawing = false;
				}
		}

		public void InitializeOpenGL(uint Handle)
		{
			_OpenGLInitialized = true;
			_OpenGLWindowHWND = Handle;
			WGL.InitOpenGL( _OpenGLWindowHWND, ref _OpenGLDC, ref _OpenGLRC );

		}

		public bool OpenGLInitialized
		{
			get { return _OpenGLInitialized; }
		}


		public float Zoom 
		{
			get { return _zoom; }
			set { _zoom = value; }
		}
		


	}
}
