using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Timers;

namespace MT.DataStructures
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class frm3DViewer : System.Windows.Forms.Form
	{
		private clsBPData				_BPData = new clsBPData();
		private cls3DView				_3DView;

		private bool					_activated = true;

		private bool					_mouseLeftDown = false;
		private float					_rotSensibility = 1.0f;     //!< mouse rotation sensibility
		private int						_startx,_starty;			//!< x,y mouse positions

		private System.Timers.Timer		_Clock = new System.Timers.Timer(20);

		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.Button btnCreate;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Panel pnlOpenGL;
		private System.Windows.Forms.TrackBar tbrFrame;
		private System.Windows.Forms.Button btnStopPlay;
		private System.Windows.Forms.Button btnStartPlay;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		public frm3DViewer()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			_3DView = new cls3DView(_BPData);
			_3DView.Initialize(this.pnlOpenGL.Width, this.pnlOpenGL.Height);
			_Clock.Elapsed +=new ElapsedEventHandler(_Clock_Elapsed);

		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frm3DViewer));
			this.btnLoad = new System.Windows.Forms.Button();
			this.btnCreate = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.pnlOpenGL = new System.Windows.Forms.Panel();
			this.tbrFrame = new System.Windows.Forms.TrackBar();
			this.btnStopPlay = new System.Windows.Forms.Button();
			this.btnStartPlay = new System.Windows.Forms.Button();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).BeginInit();
			this.SuspendLayout();
			// 
			// btnLoad
			// 
			this.btnLoad.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnLoad.Location = new System.Drawing.Point(664, 40);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.Size = new System.Drawing.Size(168, 24);
			this.btnLoad.TabIndex = 0;
			this.btnLoad.Text = "Load";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// btnCreate
			// 
			this.btnCreate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCreate.Location = new System.Drawing.Point(664, 8);
			this.btnCreate.Name = "btnCreate";
			this.btnCreate.Size = new System.Drawing.Size(168, 24);
			this.btnCreate.TabIndex = 0;
			this.btnCreate.Text = "Create";
			this.btnCreate.Click += new System.EventHandler(this.btnCreate_Click);
			// 
			// btnSave
			// 
			this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSave.Location = new System.Drawing.Point(664, 72);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(168, 24);
			this.btnSave.TabIndex = 0;
			this.btnSave.Text = "Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// pnlOpenGL
			// 
			this.pnlOpenGL.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlOpenGL.BackColor = System.Drawing.SystemColors.Window;
			this.pnlOpenGL.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlOpenGL.Location = new System.Drawing.Point(8, 8);
			this.pnlOpenGL.Name = "pnlOpenGL";
			this.pnlOpenGL.Size = new System.Drawing.Size(640, 432);
			this.pnlOpenGL.TabIndex = 1;
			this.pnlOpenGL.Resize += new System.EventHandler(this.pnlOpenGL_Resize);
			this.pnlOpenGL.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseUp);
			this.pnlOpenGL.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlOpenGL_Paint);
			this.pnlOpenGL.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseMove);
			this.pnlOpenGL.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.Panel_MouseWheel);
			this.pnlOpenGL.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseDown);
			// 
			// tbrFrame
			// 
			this.tbrFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbrFrame.AutoSize = false;
			this.tbrFrame.Location = new System.Drawing.Point(0, 440);
			this.tbrFrame.Maximum = 0;
			this.tbrFrame.Name = "tbrFrame";
			this.tbrFrame.Size = new System.Drawing.Size(656, 24);
			this.tbrFrame.TabIndex = 36;
			this.tbrFrame.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbrFrame.ValueChanged += new System.EventHandler(this.tbrFrame_ValueChanged);
			this.tbrFrame.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.Panel_MouseWheel);
			// 
			// btnStopPlay
			// 
			this.btnStopPlay.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnStopPlay.ImageIndex = 1;
			this.btnStopPlay.ImageList = this.imageList1;
			this.btnStopPlay.Location = new System.Drawing.Point(728, 440);
			this.btnStopPlay.Name = "btnStopPlay";
			this.btnStopPlay.Size = new System.Drawing.Size(32, 23);
			this.btnStopPlay.TabIndex = 38;
			this.btnStopPlay.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnStopPlay.Click += new System.EventHandler(this.btnStopPlay_Click);
			// 
			// btnStartPlay
			// 
			this.btnStartPlay.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnStartPlay.ImageIndex = 0;
			this.btnStartPlay.ImageList = this.imageList1;
			this.btnStartPlay.Location = new System.Drawing.Point(688, 440);
			this.btnStartPlay.Name = "btnStartPlay";
			this.btnStartPlay.Size = new System.Drawing.Size(32, 23);
			this.btnStartPlay.TabIndex = 37;
			this.btnStartPlay.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnStartPlay.Click += new System.EventHandler(this.btnStartPlay_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Red;
			// 
			// frm3DViewer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(840, 469);
			this.Controls.Add(this.btnStopPlay);
			this.Controls.Add(this.btnStartPlay);
			this.Controls.Add(this.tbrFrame);
			this.Controls.Add(this.pnlOpenGL);
			this.Controls.Add(this.btnLoad);
			this.Controls.Add(this.btnCreate);
			this.Controls.Add(this.btnSave);
			this.Name = "frm3DViewer";
			this.Text = "Viewer";
			this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.Panel_MouseWheel);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frm3DViewer());
		}

		private void btnCreate_Click(object sender, System.EventArgs e)
		{
			_BPData = new clsBPData();

			_BPData.Add(new clsBPStream("Grnes_Ende"	 , eColorCode.G,   0,0, 500));
			_BPData.Add(new clsBPStream("Rotes_Ende"	 , eColorCode.R,   0,0,1500));

			_BPData.Add(new clsBPConnector("Stab",		  _BPData["Grnes_Ende"],	 _BPData["Rotes_Ende"],	0.05f));

//			_BPData.Add(new clsBPStream("Hand_Links"	 , eColorCode.R,   0,-200,1200));
//			_BPData.Add(new clsBPStream("Hand_Rechts"	 , eColorCode.B,   0, 200,1200));
//			_BPData.Add(new clsBPStream("Huefte_Rechts"	 , eColorCode.R,   0, 200,1100));
//			_BPData.Add(new clsBPStream("Fuss_Links"	 , eColorCode.R,   0,-200, 200));
//			_BPData.Add(new clsBPStream("Ellbogen_Links" , eColorCode.B,   0,-400,1200));
//			_BPData.Add(new clsBPStream("Schulter_Rechts", eColorCode.R,   0, 200,1600));
//			_BPData.Add(new clsBPStream("Knie_Links"	 , eColorCode.B,   0,-200, 600));
//			_BPData.Add(new clsBPStream("Fuss_Rechts"	 , eColorCode.B,   0, 200, 200));
//			_BPData.Add(new clsBPStream("Kopf"			 , eColorCode.G,   0,   0,1800));
//			_BPData.Add(new clsBPStream("Schulter_Links" , eColorCode.G,   0,-200,1600));
//			_BPData.Add(new clsBPStream("Ellbogen_Rechts", eColorCode.G,   0, 400,1450));
//			_BPData.Add(new clsBPStream("Huefte_Links"	 , eColorCode.G,   0,-200,1100));
//			_BPData.Add(new clsBPStream("Knie_Rechts"	 , eColorCode.G,   0, 200, 600));
//
//			_BPData.Add(new clsBPConnector("Elle_Links",		  _BPData["Hand_Links"],	 _BPData["Ellbogen_Links"],												     0.15f));
//			_BPData.Add(new clsBPConnector("Elle_Rechts",		  _BPData["Hand_Rechts"],	 _BPData["Ellbogen_Rechts"],												 0.15f));
//			_BPData.Add(new clsBPConnector("Oberarm_Links",		  _BPData["Ellbogen_Links"], _BPData["Schulter_Links"],												     0.15f));
//			_BPData.Add(new clsBPConnector("Oberarm_Rechts",	  _BPData["Ellbogen_Rechts"],_BPData["Schulter_Rechts"],												 0.15f));
//			_BPData.Add(new clsBPConnector("Schultern",			  _BPData["Schulter_Rechts"],_BPData["Schulter_Links"],												     0.15f));
//			_BPData.Add(new clsBPConnector("Hals",				  _BPData["Kopf"],		     _BPData["Schulter_Rechts"],_BPData["Schulter_Links"],					     0.3f ));
//			_BPData.Add(new clsBPConnector("Rumpf",				  _BPData["Schulter_Rechts"],_BPData["Schulter_Links"], _BPData["Huefte_Rechts"],_BPData["Huefte_Links"],0.5f ));
//			_BPData.Add(new clsBPConnector("Becken",			  _BPData["Huefte_Rechts"],  _BPData["Huefte_Links"],												     0.15f));
//			_BPData.Add(new clsBPConnector("Oberschenkel_Rechts", _BPData["Huefte_Rechts"],  _BPData["Knie_Rechts"],													 0.15f));
//			_BPData.Add(new clsBPConnector("Oberschenkel_Links",  _BPData["Huefte_Links"],   _BPData["Knie_Links"],													     0.15f));
//			_BPData.Add(new clsBPConnector("Unterschenkel_Rechts",_BPData["Knie_Rechts"],	 _BPData["Fuss_Rechts"],													 0.15f));
//			_BPData.Add(new clsBPConnector("Unterschenkel_Links", _BPData["Knie_Links"],	 _BPData["Fuss_Links"],													     0.15f));
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			const string clipFileFilters =
					  "MotionXTrack Files (mxt)|*.mxt|" +
					  "All Files (*.*)|*.*";

			SaveFileDialog af = new SaveFileDialog();
			af.Title = "Save mxt File...";
			af.Filter = clipFileFilters;
			if( af.ShowDialog() != DialogResult.OK )
				return;
			
			_BPData.Save(af.FileName);
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			const string clipFileFilters =
					  "MotionXTrack Files (mxt)|*.mxt|" +
					  "All Files (*.*)|*.*";

			OpenFileDialog af = new OpenFileDialog();
			af.Title = "Open mxt File...";
			af.Filter = clipFileFilters;
			if( af.ShowDialog() != DialogResult.OK )
				return;

			_BPData.Load(af.FileName);

			this.Text = "Viewer - " + af.FileName;

			UpdateFields();

			OnReDraw();
		}

		private void UpdateFields()
		{
			tbrFrame.Minimum = _BPData.FirstFrame;
			tbrFrame.Maximum = _BPData.LastFrame;
			tbrFrame.Value = tbrFrame.Minimum;
		}

		private void tbrFrame_ValueChanged(object sender, EventArgs e)
		{
			TrackBar tb= sender as TrackBar;
			if (tb !=null)
				_3DView.curFrame = tb.Value;

			OnReDraw();

		}

		private void Panel_MouseWheel(object sender, MouseEventArgs e)
		{
			_3DView.Zoom += e.Delta;		
			OnReDraw();
		}

		bool _redrawing = false;

		delegate void OnReDrawDelegate();
		public void OnReDraw()
		{
			if(_activated && !_redrawing )
			{
				if (this.pnlOpenGL.InvokeRequired)
				{
					this.pnlOpenGL.BeginInvoke(new OnReDrawDelegate(OnReDraw),new object[]{});
				}
				else
				{
					if (!_3DView.OpenGLInitialized)
					{
						_3DView.InitializeOpenGL((uint)((this.pnlOpenGL.Handle).ToInt32()));
					}
					_redrawing = true;
					_3DView.OnReDraw();
					Application.DoEvents();
					_redrawing =false;

				}
			}
			else
				Console.WriteLine("missedFrame");

		}

		private void pnlOpenGL_Resize(object sender, EventArgs e)
		{
			_3DView.Initialize(pnlOpenGL.Width, pnlOpenGL.Height);
			OnReDraw();
		}

		private void pnlOpenGL_Paint(object sender, PaintEventArgs e)
		{
			OnReDraw();
		}

		private void pnlOpenGL_MouseMove(object sender, MouseEventArgs e)
		{
			if (_mouseLeftDown)
			{
				_3DView.DX = (e.X - _startx)*_rotSensibility; // calculate delta angle
				_3DView.DY = (e.Y - _starty)*_rotSensibility;
			
				OnReDraw();

			}
		}

		private void pnlOpenGL_MouseDown(object sender, MouseEventArgs e)
		{
			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = true;
					_startx = e.X;                      // keep start position
					_starty = e.Y;
					break;

				case MouseButtons.Right:
					
					_3DView.InitRotation();
					OnReDraw();
					break;
			}
		}

		private void pnlOpenGL_MouseUp(object sender, MouseEventArgs e)
		{
			switch (e.Button) 
			{
				case MouseButtons.Left:
					
					_mouseLeftDown = false;

					_3DView.AddRotation();
					
					break;
			}
		}

		private void btnStartPlay_Click(object sender, System.EventArgs e)
		{
			_Clock.AutoReset = true;
			_Clock.Start();
		}

		private void btnStopPlay_Click(object sender, System.EventArgs e)
		{
			_Clock.Stop();
			tbrFrame.Value = _BPData.FirstFrame;

			OnReDraw();

		}

		private void _Clock_Elapsed(object sender, ElapsedEventArgs e)
		{
			if (tbrFrame.Value < tbrFrame.Maximum)
				tbrFrame.Value +=1;
			else
				tbrFrame.Value = tbrFrame.Minimum;

			OnReDraw();
		}
	}
}
