// SWFilterProp.h: interface for the CSWFilterProp class
// 
//////////////////////////////////////////////////////////////////////
#pragma once

///////////////////////////////////////////////////////////////////////
//  CSWFilterProp: property page of CSWFilter
//  It provides a dialogbox to setup the CSWFilter.
///////////////////////////////////////////////////////////////////////
class CSWFilterProp : public CBasePropertyPage
{
public:
    static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT *phr);

private:
    // Constructor
    CSWFilterProp(LPUNKNOWN lpunk, HRESULT *phr);
    
    // Handle the messages in the dialogbox
    BOOL OnReceiveMessage(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
    // Connect the property page to filter (pUnknown) or Disconnect
    HRESULT OnConnect(IUnknown *pUnknown);
    HRESULT OnDisconnect();

    // When activate or deactivate or apply changes the property page
    HRESULT OnActivate();
    HRESULT OnDeactivate();
    HRESULT OnApplyChanges();

    // Helper functions
    void    GetControlValues(); // Read parameters from controls
    void    SetControlValues(); // Set controls according to parameters

    BOOL m_bIsInitialized; // Used to ignore startup messages
    ISWFilter *m_pISWFilter;  // interface of the filter
    SWFilterParams m_SWFilterParams; // Filter parameters
};

