// iSWFilter.h: interface for the CSWFilter class
//
//////////////////////////////////////////////////////////////////////
// Classes defined:
//
//   GUIDs of Filter CSWFilter, Interface ISWFilter and 
//       its property page CSWFilterProp
//   SWFilterParams:
//       The parameters that control the CSWFilter
//   ISWFilter:
//       The interface that controls the CSWFilter.
//////////////////////////////////////////////////////////////////////
#pragma once

// The parameter control the CSWFilter.
struct SWFilterParams {
    int		intFilter;
	int		intNet;
	int		intPort;
	int		intThreshold;
	int		intZoneThreshold;
	int		blnDrawFeaturePoints;	
	int		intSync;
};
/*struct SWFilterParams {
    int   param1;
    int   param2;
	int   param3;
    //int   param4;
    char*  param4;
    int   param5;
	int   param6;
	int   param7;
	

};
*/


// {a73c9900-60c7-4510-b58e-f4ded4639391}
//DEFINE_GUID(CLSID_Midl_Interface,
//0xa73c9900, 0x60c7, 0x4510, 0xb5, 0x8e, 0xf4, 0xde, 0xd4, 0x63, 0x93, 0x91);

// {16205dc4-79c7-4c04-b4a8-e0481b75d825}
DEFINE_GUID(CLSID_SWFilter, 
0x16205dc4, 0x79c7, 0x4c04, 0xb4, 0xa8, 0xe0, 0x48, 0x1b, 0x75, 0xd8, 0x25);

// {b9bbb753-d0c1-4b81-97ca-f2c9335980dc}
DEFINE_GUID(CLSID_SWFilterProp, 
0xb9bbb753, 0xd0c1, 0x4b81, 0x97, 0xca, 0xf2, 0xc9, 0x33, 0x59, 0x80, 0xdc);

// {67cf7b10-2cd1-47cc-861d-bc8ea7958578}
DEFINE_GUID(IID_ISWFilter, 
0x67cf7b10, 0x2cd1, 0x47cc, 0x86, 0x1d, 0xbc, 0x8e, 0xa7, 0x95, 0x85, 0x78);

#ifdef __cplusplus
extern "C" {
#endif

DECLARE_INTERFACE_(ISWFilter, IUnknown)
{
    // Get the parameters of the filter
    STDMETHOD(GetParams) (THIS_
                SWFilterParams *irp
             ) PURE;

    // Set the parameters of the filter
    STDMETHOD(SetParams) (THIS_
                SWFilterParams *irp
             ) PURE;
};

#ifdef __cplusplus
}
#endif

