/*  
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Ronald Tanner                   Created: 2004-03-10
 */

// Implementation of the ClientSocket class

#ifndef __ClientSocketCPP
#define __ClientSocketCPP
#include "ClientSocket.h"
#include "SocketException.h"


ClientSocket::ClientSocket ( std::string host, int port ){
  if ( ! Socket::create() )    {
      throw SocketException ( getError() );
  }

  if ( ! Socket::connect ( host, port ) ) {
      throw SocketException ( getError() );
  }
  
  _netbuffer.clear();

}


const ClientSocket& ClientSocket::operator << ( const std::string& s ) {

	_netbuffer.concat(s.c_str());
	
	//if (_netbuffer._curused > _maxBUFFER)
	//{
	//	if ( ! Socket::send ( _netbuffer._s ) )    {
	//		throw SocketException ( getError() );
	//	}

	//	_netbuffer.clear();
	//}

  return *this;

}




const ClientSocket& ClientSocket::operator >> ( std::string& s ) {
    if ( ! Socket::recv ( s ) ) {
	throw SocketException ( getError() );
    }
    
    return *this;
}

//Empty Buffer
void 
ClientSocket::flush()
{
	if ( ! Socket::send ( _netbuffer._s ) )    {
		throw SocketException ( getError() );
	}
	_netbuffer.clear();
}

#endif